#include "hardware_t.h"
#include "tc_vars.h"
#include "flash_t.h"
#include "display_t.h"
//#include "math.h"

// Class Display
void Display::DRAW_ALL_CURSOR(void)								// Draw the Cursors
{
	int c;
    	int BufVal1 = 0;
    	int BufVal2 = 0;
    	int BufVal3 = 0;
    	int BufVal4 = 0;
    	int BufVal5 = 0;
    	int BufVal6 = 0;
	int vert_cursor_max = GRID_HEIGHT + 1;		// BF
	
	int horz_cursor_start = 0;
	int horz_cursor_stop = GRID_WIDTH;		// BF
	
	long Cursor_Vertical_Position1 = 0;							// Store Cursor vertical I position
	long Cursor_Vertical_Position2 = 0;							// Store Cursor vertical II position
		
	long Cursor_Horizontal_Position1 = 0;							// Store Cursor horizontal I position
	long Cursor_Horizontal_Position2 = 0;							// Store Cursor horizontal II position
	
	long QM_Vertical_Position1 = 0;
	long QM_Vertical_Position2 = 0;
	
	long QM_Horizontal_Position1 = 0;
	long QM_Horizontal_Position2 = 0;
	int lXOffs = GRID_XOFFS;
	


	if (Splash_drawed) return;
	
	if (MenuStatus[MENU_TIMEBASE][1] == 1) vert_cursor_max = (GRID_HEIGHT / 2) - 2;  //BF 190;
	
	// New Trigger Position
	BufVal1 = Trig_Pos_Display + DrawOffsetX;
	BufVal2 = Trig_Pos_Display_dmode + DrawOffsetX;
	
	if (BufVal2 > (GRID_WIDTH - 1 + DrawOffsetX)) BufVal2 = GRID_WIDTH - 1 + DrawOffsetX;
	if (BufVal2 < (DrawOffsetX - 2)) BufVal2 = DrawOffsetX - 2;
	
	if (MenuStatus[MENU_TIMEBASE][1] == 0) BufVal2 = 0;
	
	//printf("BV1 : %5d BV2 : %5d\n", BufVal1, BufVal2);

	if (BufVal1 != Trig_Pos_Display_old || FFT_Mode != FFT_OFF)
	{
		// Remove Trigger Offset
		if (Trig_Pos_Display_old <= (DrawOffsetX - 2))
		{
			DRAWLINEP(Trig_Pos_Display_old + 0, 26, Trig_Pos_Display_old + 11, 26, 0, Buffer_Mark1Plane);
			
			DRAWLINEP(Trig_Pos_Display_old + 1, 25, Trig_Pos_Display_old + 1, 28, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old + 2, 24, Trig_Pos_Display_old + 2, 29, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old + 3, 23, Trig_Pos_Display_old + 3, 30, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old + 4, 22, Trig_Pos_Display_old + 4, 31, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old + 5, 21, Trig_Pos_Display_old + 5, 32, 0, Buffer_Mark1Plane);
		}
		else if (Trig_Pos_Display_old >= (GRID_WIDTH - 1 + DrawOffsetX))
		{
			DRAWLINEP(Trig_Pos_Display_old - 10, 26, Trig_Pos_Display_old + 2, 26, 0, Buffer_Mark1Plane);
		
			DRAWLINEP(Trig_Pos_Display_old - 1, 25, Trig_Pos_Display_old - 1, 28, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 2, 24, Trig_Pos_Display_old - 2, 29, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 3, 23, Trig_Pos_Display_old - 3, 30, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 4, 22, Trig_Pos_Display_old - 4, 31, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 5, 21, Trig_Pos_Display_old - 5, 32, 0, Buffer_Mark1Plane);
		}
		else
		{
			DRAWLINEP(Trig_Pos_Display_old - 3, 21, Trig_Pos_Display_old + 4, 21, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 3, 22, Trig_Pos_Display_old + 4, 22, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 3, 23, Trig_Pos_Display_old + 4, 23, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 3, 24, Trig_Pos_Display_old + 4, 24, 0, Buffer_Mark1Plane);
		
			DRAWLINEP(Trig_Pos_Display_old - 3, 25, Trig_Pos_Display_old + 4, 25, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 2, 26, Trig_Pos_Display_old + 3, 26, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_old - 1, 27, Trig_Pos_Display_old + 2, 27, 0, Buffer_Mark1Plane);
			PIXELP(Trig_Pos_Display_old, 28, 0, Buffer_Mark1Plane);
		
			DRAWLINEP(Trig_Pos_Display_old - 3, 21, Trig_Pos_Display_old + 4, 21, 0, Marker_Plane1);
			DRAWLINEP(Trig_Pos_Display_old - 3, 22, Trig_Pos_Display_old + 4, 22, 0, Marker_Plane1);
			DRAWLINEP(Trig_Pos_Display_old - 3, 23, Trig_Pos_Display_old + 4, 23, 0, Marker_Plane1);
			DRAWLINEP(Trig_Pos_Display_old - 3, 24, Trig_Pos_Display_old + 4, 24, 0, Marker_Plane1);
		
			DRAWLINEP(Trig_Pos_Display_old - 3, 25, Trig_Pos_Display_old + 4, 25, 0, Marker_Plane1);
			DRAWLINEP(Trig_Pos_Display_old - 2, 26, Trig_Pos_Display_old + 3, 26, 0, Marker_Plane1);
			DRAWLINEP(Trig_Pos_Display_old - 1, 27, Trig_Pos_Display_old + 2, 27, 0, Marker_Plane1);
			PIXELP(Trig_Pos_Display_old, 28, 0, Marker_Plane1);
		
			DRAWLINEP(Trig_Pos_Display_old - 2, 22, Trig_Pos_Display_old + 3, 22, 0, UI_Plane2);
			DRAWLINEP(Trig_Pos_Display_old, 22, Trig_Pos_Display_old, 27, 0, UI_Plane2);
		}
	}
    
	if (BufVal2 != Trig_Pos_Display_dmode_old || FFT_Mode != FFT_OFF)
	{
		if (Trig_Pos_Display_dmode_old <= (DrawOffsetX - 2))
		{
			DRAWLINEP(Trig_Pos_Display_dmode_old + 0, 227, Trig_Pos_Display_dmode_old + 11, 227, 0, Buffer_Mark1Plane);
		
			DRAWLINEP(Trig_Pos_Display_dmode_old + 1, 226, Trig_Pos_Display_dmode_old + 1, 229, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old + 2, 225, Trig_Pos_Display_dmode_old + 2, 230, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old + 3, 224, Trig_Pos_Display_dmode_old + 3, 231, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old + 4, 223, Trig_Pos_Display_dmode_old + 4, 232, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old + 5, 222, Trig_Pos_Display_dmode_old + 5, 233, 0, Buffer_Mark1Plane);
		}
		else if (Trig_Pos_Display_dmode_old >= (GRID_WIDTH - 1 + DrawOffsetX))
		{
			DRAWLINEP(Trig_Pos_Display_dmode_old - 10, 227, Trig_Pos_Display_dmode_old + 1, 227, 0, Buffer_Mark1Plane);
		
			DRAWLINEP(Trig_Pos_Display_dmode_old - 1, 226, Trig_Pos_Display_dmode_old - 1, 229, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 2, 225, Trig_Pos_Display_dmode_old - 2, 230, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 3, 224, Trig_Pos_Display_dmode_old - 3, 231, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 4, 223, Trig_Pos_Display_dmode_old - 4, 232, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 5, 222, Trig_Pos_Display_dmode_old - 5, 233, 0, Buffer_Mark1Plane);
		}
		else
		{
			// Remove Trigger sign in delayed window
			DRAWLINEP(Trig_Pos_Display_dmode_old - 5, 222, Trig_Pos_Display_dmode_old + 6, 222, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 4, 223, Trig_Pos_Display_dmode_old + 5, 223, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 3, 224, Trig_Pos_Display_dmode_old + 4, 224, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 2, 225, Trig_Pos_Display_dmode_old + 3, 225, 0, Buffer_Mark1Plane);
			DRAWLINEP(Trig_Pos_Display_dmode_old - 1, 226, Trig_Pos_Display_dmode_old + 2, 226, 0, Buffer_Mark1Plane);
			PIXELP(Trig_Pos_Display_dmode_old, 227, 0, Buffer_Mark1Plane);
		}
	}


	for (c = DrawOffsetY; c < ((GRID_HEIGHT / 2) + 1 + DrawOffsetY); c++)
	{
		// Remove vertical Cursor first	
		*(Buffer_Mark1Plane + (Cursor_Vertical_Position1_Old / 32) + (c * 20)) = 0;
		*(Buffer_Mark1Plane + (Cursor_Vertical_Position2_Old / 32) + (c * 20)) = 0;
	
		// Remove vertical quick measurement cursor
		*(Buffer_Mark1Plane + (QM_Vertical_Position1_Old / 32) + (c * 20)) = 0;
		*(Buffer_Mark1Plane + (QM_Vertical_Position2_Old / 32) + (c * 20)) = 0;
	
		// Remove delayed cursor		
		*(Buffer_Mark1Plane + (Cursor_Delayed_1_Old / 32) + (c * 20)) = 0;
		*(Buffer_Mark1Plane + (Cursor_Delayed_2_Old / 32) + (c * 20)) = 0;
	}		
       		
	for (c = ((GRID_HEIGHT / 2) + 1 + DrawOffsetY); c < (GRID_HEIGHT + 2 + DrawOffsetY); c++)
	{	
		*(Buffer_Mark1Plane + (Cursor_Vertical_Position1_Old / 32) + (c * 20)) = 0;
		*(Buffer_Mark1Plane + (Cursor_Vertical_Position2_Old / 32) + (c * 20)) = 0;
	
		*(Buffer_Mark1Plane + (QM_Vertical_Position1_Old / 32) + (c * 20)) = 0;
		*(Buffer_Mark1Plane + (QM_Vertical_Position2_Old / 32) + (c * 20)) = 0;
	
		*(Buffer_Mark1Plane + (dmode_Cursor_Vertical_Position1_Old / 32) + (c * 20)) = 0;
		*(Buffer_Mark1Plane + (dmode_Cursor_Vertical_Position2_Old / 32) + (c * 20)) = 0;
	
		*(Buffer_Mark1Plane + (dmode_QM_Vertical_Position1_Old / 32) + (c * 20)) = 0;
		*(Buffer_Mark1Plane + (dmode_QM_Vertical_Position2_Old / 32) + (c * 20)) = 0;
	}

	for (c = 0; c < 20; c++)
	{
		// Remove horizontal cursor first	
		*(Buffer_Mark1Plane + (Cursor_Horizontal_Position1_Old * 20) + c) = 0;
		*(Buffer_Mark1Plane + (Cursor_Horizontal_Position2_Old * 20) + c) = 0;	
	
		// Remove horizontal quick measurement cursor
		*(Buffer_Mark1Plane + (QM_Horizontal_Position1_Old * 20) + c) = 0;
		*(Buffer_Mark1Plane + (QM_Horizontal_Position2_Old * 20) + c) = 0;	
	
		// Remove horizontal cursor first	
		*(Buffer_Mark1Plane + ((Cursor_Horizontal_Position1_Old + (GRID_HEIGHT / 2) + 1) * 20) + c) = 0;
		*(Buffer_Mark1Plane + ((Cursor_Horizontal_Position2_Old + (GRID_HEIGHT / 2) + 1) * 20) + c) = 0;	
	
		// Remove horizontal quick measurement cursor
		*(Buffer_Mark1Plane + ((QM_Horizontal_Position1_Old + (GRID_HEIGHT / 2) + 1) * 20) + c) = 0;
		*(Buffer_Mark1Plane + ((QM_Horizontal_Position2_Old + (GRID_HEIGHT / 2) + 1) * 20) + c) = 0;
	}
	
	// Everything removed - start drawing

	// Draw Tigger sign in main window
	// Draw the filled Triangle for Offset Position
	if (XY_Mode == 0 && FFT_Mode == FFT_OFF)	//Main mode
	{

		if (BufVal1 <= (DrawOffsetX - 2))
		{
			BufVal1 = DrawOffsetX - 2;
		
			DRAWLINEP(BufVal1 + 0, 26, BufVal1 + 11, 26, 1, Buffer_Mark1Plane);
		
			DRAWLINEP(BufVal1 + 1, 25, BufVal1 + 1, 28, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 + 2, 24, BufVal1 + 2, 29, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 + 3, 23, BufVal1 + 3, 30, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 + 4, 22, BufVal1 + 4, 31, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 + 5, 21, BufVal1 + 5, 32, 1, Buffer_Mark1Plane);
	
		}
		else if (BufVal1 >= (GRID_WIDTH - 1 + DrawOffsetX))
		{
			BufVal1 = GRID_WIDTH - 1 + DrawOffsetX;
		
			DRAWLINEP(BufVal1 - 10, 26, BufVal1 + 1, 26, 1, Buffer_Mark1Plane);
		
			DRAWLINEP(BufVal1 - 1, 25, BufVal1 - 1, 28, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 2, 24, BufVal1 - 2, 29, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 3, 23, BufVal1 - 3, 30, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 4, 22, BufVal1 - 4, 31, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 5, 21, BufVal1 - 5, 32, 1, Buffer_Mark1Plane);
	
		}
		else
		{
			DRAWLINEP(BufVal1 - 3, 21, BufVal1 + 4, 21, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 3, 22, BufVal1 + 4, 22, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 3, 23, BufVal1 + 4, 23, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 3, 24, BufVal1 + 4, 24, 1, Buffer_Mark1Plane);
		
			DRAWLINEP(BufVal1 - 3, 25, BufVal1 + 4, 25, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 2, 26, BufVal1 + 3, 26, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal1 - 1, 27, BufVal1 + 2, 27, 1, Buffer_Mark1Plane);
			PIXELP(BufVal1, 28, 1, Buffer_Mark1Plane);
		
			DRAWLINEP(BufVal1 - 3, 21, BufVal1 + 4, 21, 1, Marker_Plane1);
			DRAWLINEP(BufVal1 - 3, 22, BufVal1 + 4, 22, 1, Marker_Plane1);
			DRAWLINEP(BufVal1 - 3, 23, BufVal1 + 4, 23, 1, Marker_Plane1);
			DRAWLINEP(BufVal1 - 3, 24, BufVal1 + 4, 24, 1, Marker_Plane1);
		
			DRAWLINEP(BufVal1 - 3, 25, BufVal1 + 4, 25, 1, Marker_Plane1);
			DRAWLINEP(BufVal1 - 2, 26, BufVal1 + 3, 26, 1, Marker_Plane1);
			DRAWLINEP(BufVal1 - 1, 27, BufVal1 + 2, 27, 1, Marker_Plane1);
			PIXELP(BufVal1, 28, 1, Marker_Plane1);
		
			DRAWLINEP(BufVal1 - 2, 22, BufVal1 + 3, 22, 1, UI_Plane2);
			DRAWLINEP(BufVal1, 22, BufVal1, 27, 1, UI_Plane2);
		}

		//Trigger_Offset_Pos_Old = BufVal1; // Save actual position	
		Trig_Pos_Display_old = BufVal1; // Save actual position	

#ifdef _Debug_
//        if (Debug_Mode) printf("trof %d trofold %d bufval %d tof %d st %d sfi %d dmst %d dmsfi %d dwop %d df %f  cd1 %d cd2 %d  vc1 %d vc2 %d \n", Trigger_Offset_Pos, Trigger_Offset_Pos_Old, BufVal1, Timebase_Offset_Pos, Selected_Timebase, SIGNALFaktor_idx, dmode_Selected_Timebase, dmode_SIGNALFaktor_idx, dmode_Window_Offset_Pos, dmode_factor, Cursor_Delayed_1, Cursor_Delayed_2, Cursor_Vertical_Position_Real1, Cursor_Vertical_Position_Real2);
#endif        		
        	//--------------------------------------------------
		// Draw Trigger in delayed window
		//--------------------------------------------------
		if (MenuStatus[MENU_TIMEBASE][1] == 1)
		{

#ifdef _Debug_
//            if (Debug_Mode) printf("TrOfPo %d bv : %d dWOP %d df %f cd1 %d SS %d\n", Trigger_Offset_Pos, BufVal1, dmode_Window_Offset_Pos, dmode_factor, Cursor_Delayed_1, SIG_Start_Stop[ZIT_short][0] + (int)((float) Timebase_Offset_Pos * OFT_float));
#endif

			DRAWLINEP(BufVal2 - 5, 222, BufVal2 + 6, 222, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal2 - 4, 223, BufVal2 + 5, 223, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal2 - 3, 224, BufVal2 + 4, 224, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal2 - 2, 225, BufVal2 + 3, 225, 1, Buffer_Mark1Plane);
			DRAWLINEP(BufVal2 - 1, 226, BufVal2 + 2, 226, 1, Buffer_Mark1Plane);
			PIXELP(BufVal2, 227, 1, Buffer_Mark1Plane);

			//dmode_Trigger_Offset_Pos_Old = BufVal2;
			Trig_Pos_Display_dmode_old = BufVal2;
		
			// draw delayed cursor
			BufVal1 = Cursor_Delayed_1 + DrawOffsetX;
			BufVal2 = Cursor_Delayed_2 + DrawOffsetX;
		
			if (BufVal1 > (GRID_WIDTH + DrawOffsetX)) BufVal1 = GRID_WIDTH + DrawOffsetX;
			if (BufVal1 < DrawOffsetX) BufVal1 = DrawOffsetX;
			if (BufVal2 > (GRID_WIDTH + DrawOffsetX)) BufVal2 = GRID_WIDTH + DrawOffsetX;
			if (BufVal2 < DrawOffsetX) BufVal2 = DrawOffsetX;

			for (c = 0; c < ((GRID_HEIGHT / 2) + 1); c++)
			{			
				if (c % 2 == 0) PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
				if ((c + 1) % 2 == 0) PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
			}
		
			Cursor_Delayed_1_Old = BufVal1;
			Cursor_Delayed_2_Old = BufVal2;
        	}
    	}

	//-----------------------------
	// Draw Cursor
	//-----------------------------
	if (Cursor_Enabled)
	{

		//------------------------------------------------------------------------------------------
		//	limit cursor position  						BF changed
		//------------------------------------------------------------------------------------------

		// vertical
		if (XY_Mode)	//XY-Mode
		{
			Cursor_Vertical_Position1 = Cursor_Vertical_Position_Real_XY_1;
			Cursor_Vertical_Position2 = Cursor_Vertical_Position_Real_XY_2;

			if (Cursor_Vertical_Position1 < 0) Cursor_Vertical_Position1 = 0;
			else if (Cursor_Vertical_Position1 > GRID_XY) Cursor_Vertical_Position1 = GRID_XY;	
			
			if (Cursor_Vertical_Position2 < 0) Cursor_Vertical_Position2 = 0;
			else if (Cursor_Vertical_Position2 > GRID_XY) Cursor_Vertical_Position2 = GRID_XY;

			//Absolute position for X1 and X2 cursor
			BufVal1 = Cursor_Vertical_Position1 + GRID_XY_XOFFS;
			BufVal2 = Cursor_Vertical_Position2 + GRID_XY_XOFFS;

		}	
		else if (FFT_Mode != FFT_OFF)	//FFT
		{
			Cursor_Vertical_Position1 = Cursor_Vertical_Position_Real1;
			Cursor_Vertical_Position2 = Cursor_Vertical_Position_Real2;

			//Cursor_Vertical_Position1 = Cursor_Vertical_Position_Real1;
			if (Cursor_Vertical_Position1 > GRID_WIDTH_FFT) Cursor_Vertical_Position1 = GRID_WIDTH_FFT;
			else if (Cursor_Vertical_Position1 < 0) Cursor_Vertical_Position1 = 0;	
			
			//Cursor_Vertical_Position2 = Cursor_Vertical_Position_Real2;
			if (Cursor_Vertical_Position2 > GRID_WIDTH_FFT) Cursor_Vertical_Position2 = GRID_WIDTH_FFT;
			else if (Cursor_Vertical_Position2 < 0) Cursor_Vertical_Position2 = 0;

			//Absolute position for X1 and X2 cursor
			BufVal1 = Cursor_Vertical_Position1 + GRID_XOFFS_FFT;
			BufVal2 = Cursor_Vertical_Position2 + GRID_XOFFS_FFT;

		}
		else	//main + delayed timebase cursor
		{
			Cursor_Vertical_Position1 = (int) (((float) Cursor_Vertical_Position_Real1 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) / ZFT_float);
			Cursor_Vertical_Position2 = (int) (((float) Cursor_Vertical_Position_Real2 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) / ZFT_float);

			//Cursor_Vertical_Position1 = Cursor_Vertical_Position_Real1;
			if (Cursor_Vertical_Position1 > GRID_WIDTH) Cursor_Vertical_Position1 = GRID_WIDTH;
			else if (Cursor_Vertical_Position1 < 0) Cursor_Vertical_Position1 = 0;	
			
			//Cursor_Vertical_Position2 = Cursor_Vertical_Position_Real2;
			if (Cursor_Vertical_Position2 > GRID_WIDTH) Cursor_Vertical_Position2 = GRID_WIDTH;
			else if (Cursor_Vertical_Position2 < 0) Cursor_Vertical_Position2 = 0;

			//Absolute position for X1 and X2 cursor
			BufVal1 = Cursor_Vertical_Position1 + GRID_XOFFS;
			BufVal2 = Cursor_Vertical_Position2 + GRID_XOFFS;

		}	

		// horizontal
		Cursor_Horizontal_Position1 = Cursor_Horizontal_Position_Real1;
		if (Cursor_Horizontal_Position1 > GRID_HEIGHT) Cursor_Horizontal_Position1 = GRID_HEIGHT;
		else if (Cursor_Horizontal_Position1 < 0) Cursor_Horizontal_Position1 = 0;
			
		Cursor_Horizontal_Position2 = Cursor_Horizontal_Position_Real2;
		if (Cursor_Horizontal_Position2 > GRID_HEIGHT) Cursor_Horizontal_Position2 = GRID_HEIGHT;
		else if (Cursor_Horizontal_Position2 < 0) Cursor_Horizontal_Position2 = 0;
	



/* BFTEST must be checked becouse of wrong Cursorposition */

		if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
		{
			BufVal3 = ((int)((float) (Cursor_Vertical_Position1 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) +
			 SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
				((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + 
				(int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;
				

			if (BufVal3 > (GRID_WIDTH + DrawOffsetX)) BufVal3 = (GRID_WIDTH + DrawOffsetX);
			if (BufVal3 < DrawOffsetX) BufVal3 = DrawOffsetX;
		
			BufVal4 = ((int)((float) (Cursor_Vertical_Position2 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) +
			 SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
				((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + 
				(int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;
		
		
			if (BufVal4 > (GRID_WIDTH + DrawOffsetX)) BufVal4 = (GRID_WIDTH + DrawOffsetX);
			if (BufVal4 < DrawOffsetX) BufVal4 = DrawOffsetX;
		}
/* BF end	*/

		// Draw New Vertical Cursor
		switch(Cursor_Vertical_Active)
		{
			// Cursor 1 is active
			case 1:
			{
		
			if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
			{
				//Cursor upper window in delayed grid
				for (c = 0; c < vert_cursor_max; c++)
				{
					PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
					if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
				}
				//Cursor lower window in delayed grid
				for (c = ((GRID_HEIGHT / 2) + 2); c < (GRID_HEIGHT + 1); c++)
				{
					PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
					if (c %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
				}
			}
			else	//Not delayed
			{
				//Main Grid full height
				for (c = 0; c < vert_cursor_max; c++)
				{
					PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
					if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
				}
			}
			break;
		}
		// Cursor 2 is active
		case 2:
		{
			if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
			{
				for (c = 0; c < vert_cursor_max; c++)
				{
					if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
					PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
				}
	
				for (c = ((GRID_HEIGHT / 2) + 2); c < (GRID_HEIGHT + 1); c++)
				{
					if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
					PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
				}
			}
			else
			{
				for (c = 0; c < vert_cursor_max; c++)
				{
					if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
					PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
				}
			}
                	break;
            	}	
		// None Cursor is active
		case 3:
		{
			if (MenuStatus[MENU_TIMEBASE][1] == 1)
			{
				for (c = 0; c < vert_cursor_max; c++)
				{
					if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
					if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
				}
	
			for (c = ((GRID_HEIGHT / 2) + 2); c < (GRID_HEIGHT + 1); c++)
				{
					if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
					if ((c + 4) %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
				}
			}
			else
			{
				for (c = 0; c < vert_cursor_max; c++)
				{
					if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
					if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
				}
			}
			break;
		}	
		// Both Cursor are active
		case 4:
		{
			if (MenuStatus[MENU_TIMEBASE][1] == 1)
			{
				for (c = 0; c < vert_cursor_max; c++)
				{
					PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
					PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
				}
	
				for (c = ((GRID_HEIGHT / 2) + 2); c < (GRID_HEIGHT + 1); c++)	// BF +1????
				{
					PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane);
					PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
				}
			}
			else
			{
				for (c = 0; c < vert_cursor_max; c++)
				{
					PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
					PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
				}
			}
			break;
		}			
	}//switch end
		
	Cursor_Vertical_Position1_Old = BufVal1;
	Cursor_Vertical_Position2_Old = BufVal2;
	dmode_Cursor_Vertical_Position1_Old = BufVal3;
	dmode_Cursor_Vertical_Position2_Old = BufVal4;
	Cursor_Vertical_Active_Old = Cursor_Vertical_Active;

        if (MenuStatus[MENU_TIMEBASE][1] == 1)
        {
		BufVal1 = (Cursor_Horizontal_Position1 >> 1) + DrawOffsetY;
		BufVal2 = (Cursor_Horizontal_Position2 >> 1) + DrawOffsetY;	
        }
        else
        {
		BufVal1 = Cursor_Horizontal_Position1 + DrawOffsetY;
		BufVal2 = Cursor_Horizontal_Position2 + DrawOffsetY;	
        }

/*BF del
        if (XY_Mode == 1)	//X-Y Mode
        {
		horz_cursor_start = DrawXYOffsetX1;
		horz_cursor_stop = DrawXYOffsetX2 - 5;
        }
        else
        {
		horz_cursor_start = 0;
		horz_cursor_stop = GRID_WIDTH;
        }
*/



	//--------------------------------------------------------------------------------------
	//BF new horizontal cursor dimension for FFT and XY due to the variing grid width
	//--------------------------------------------------------------------------------------
	
	if (XY_Mode)			// XY
	{
		lXOffs = GRID_XY_XOFFS;
		horz_cursor_start = 0;
		horz_cursor_stop = GRID_XY - 4;
	
	}
	else if(FFT_Mode != FFT_OFF)	// FFT
	{
		lXOffs = GRID_XOFFS_FFT;
		horz_cursor_start = 0;
		horz_cursor_stop = GRID_WIDTH_FFT - 4;
	
	}
	else				// main + delayed
	{
		lXOffs = GRID_XOFFS;
		horz_cursor_start = 0;
		horz_cursor_stop = GRID_WIDTH - 4;
	}

        // Draw New Horizontal Cursor
        switch(Cursor_Horizontal_Active)
        {
            // Cursor 1 is active
            case 1:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        PIXELP(c + lXOffs, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        PIXELP(c + lXOffs, BufVal1 + (GRID_HEIGHT / 2) + 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal2 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else	//not delayed
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + lXOffs, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // Cursor 2 is active
            case 2:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + lXOffs, BufVal2, 1, Buffer_Mark1Plane);			

                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal1 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + lXOffs, BufVal2 + ((GRID_HEIGHT / 2) + 1), 1, Buffer_Mark1Plane);	
                    }
                }
                else	//not delayed
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + lXOffs, BufVal2, 1, Buffer_Mark1Plane);			
                    }
                }
                break;
            }
            // None Cursor is active
            case 3:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal1 + (GRID_HEIGHT / 2) + 1, 6, 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal2 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else	//not delayed
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + lXOffs, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // Both Cursor are active
            case 4:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        PIXELP(c + lXOffs, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + lXOffs, BufVal2, 1, Buffer_Mark1Plane);

                        PIXELP(c + lXOffs, BufVal1 + (GRID_HEIGHT / 2) + 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + lXOffs, BufVal2 + (GRID_HEIGHT / 2) + 1, 1, Buffer_Mark1Plane);
                    }
                }
                else	//not delayed
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + lXOffs, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + lXOffs, BufVal2, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }					
		}
		
		Cursor_Horizontal_Position1_Old = BufVal1;
		Cursor_Horizontal_Position2_Old = BufVal2;
		Cursor_Horizontal_Active_Old = Cursor_Horizontal_Active;
	}	
	
	// Draw quick measurment cursor
    if (QM_Enabled)
    {
        QM_Vertical_Position1 = QM_Vertical_Position_Real1;
        if (QM_Vertical_Position1 > GRID_WIDTH) QM_Vertical_Position1 = GRID_WIDTH;
        else if (QM_Vertical_Position1 < 0) QM_Vertical_Position1 = 0;	
	
        QM_Vertical_Position2 = QM_Vertical_Position_Real2;
        if (QM_Vertical_Position2 > GRID_WIDTH) QM_Vertical_Position2 = GRID_WIDTH;
        else if (QM_Vertical_Position2 < 0) QM_Vertical_Position2 = 0;	
	
        QM_Horizontal_Position1 = QM_Horizontal_Position_Real1;
        if (QM_Horizontal_Position1 > GRID_HEIGHT) QM_Horizontal_Position1 = GRID_HEIGHT;
        else if (QM_Horizontal_Position1 < 0) QM_Horizontal_Position1 = 0;
		
        QM_Horizontal_Position2 = QM_Horizontal_Position_Real2;
        if (QM_Horizontal_Position2 > GRID_HEIGHT) QM_Horizontal_Position2 = GRID_HEIGHT;
        else if (QM_Horizontal_Position2 < 0) QM_Horizontal_Position2 = 0;		
	
        if (XY_Mode == 1)
        {
            if (QM_Vertical_Position1 < DrawXYOffsetX1) QM_Vertical_Position1 = DrawXYOffsetX1;
            else if (QM_Vertical_Position1 > DrawXYOffsetX2) QM_Vertical_Position1 = DrawXYOffsetX2;	
	
            if (QM_Vertical_Position2 < DrawXYOffsetX1) QM_Vertical_Position2 = DrawXYOffsetX1;
            else if (QM_Vertical_Position2 > DrawXYOffsetX2) QM_Vertical_Position2 = DrawXYOffsetX2;
        }		
	
        BufVal1 = QM_Vertical_Position1 + DrawOffsetX - 2;// + 18;
        BufVal2 = QM_Vertical_Position2 + DrawOffsetX - 2;// + 18;

        if (MenuStatus[MENU_TIMEBASE][1] == 1)
        {
            BufVal3 = ((int)((float) (QM_Vertical_Position1 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) + SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
                ((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;

            if (BufVal3 > (GRID_WIDTH + DrawOffsetX)) BufVal3 = (GRID_WIDTH + DrawOffsetX);
            if (BufVal3 < DrawOffsetX) BufVal3 = DrawOffsetX;

            BufVal4 = ((int)((float) (QM_Vertical_Position2 - Cursor_Delayed_1) * dmode_factor) + (int) ((float) Cursor_Delayed_1 * ZFT_float) + SIG_Start_Stop[ZIT_short][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) -
                ((int) ((float) dmode_Window_Offset_Pos * ZFT_float) + SIG_Start_Stop[ZIT_short_dmode][0] + (int) ((float) Timebase_Offset_Pos * OFT_float)) + DrawOffsetX;

            if (BufVal4 > (GRID_WIDTH + DrawOffsetX)) BufVal4 = (GRID_WIDTH + DrawOffsetX);
            if (BufVal4 < DrawOffsetX) BufVal4 = DrawOffsetX;
        }

        // Draw New Vertical Cursor
        switch(QM_Vertical_Active)
        {
            // Cursor 1 is active
            case 1:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                    for (c = (GRID_HEIGHT / 2) + 2; c < (GRID_HEIGHT + 1); c++)	// BF +1??
                    {
                        PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane); 		
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // Cursor 2 is active
            case 2:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                    for (c = (GRID_HEIGHT / 2) + 2; c < (GRID_HEIGHT + 1); c++)	// BF +1??
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // None Cursor is active
            case 3:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = (GRID_HEIGHT / 2) + 2; c < (GRID_HEIGHT + 1); c++)	// BF +1??
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // Both Cursor are active
            case 4:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }

                    for (c = (GRID_HEIGHT / 2) + 2; c < (GRID_HEIGHT + 1); c++)	// BF +1??
                    {
                        PIXELP(BufVal3, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal4, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        PIXELP(BufVal1, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                        PIXELP(BufVal2, c + DrawOffsetY, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // only Cursor 1 is active
            case 5:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = (GRID_HEIGHT / 2) + 2; c < (GRID_HEIGHT + 1); c++)	// BF +1??
                    {
                        if (c %10 == 0) DRAWP(BufVal3, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal1, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // only Cursor 2 is active
            case 6:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }

                    for (c = (GRID_HEIGHT / 2) + 2; c < (GRID_HEIGHT + 1); c++)	// BF +1??
                    {
                        if (c %10 == 0) DRAWP(BufVal4, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = 0; c < vert_cursor_max; c++)
                    {
                        if (c %10 == 0) DRAWP(BufVal2, c + DrawOffsetY, 1, 6, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
		}
		
		QM_Vertical_Position1_Old = BufVal1;
		QM_Vertical_Position2_Old = BufVal2;
		dmode_QM_Vertical_Position1_Old = BufVal3;
		dmode_QM_Vertical_Position2_Old = BufVal4;
		QM_Vertical_Active_Old = QM_Vertical_Active;

        if (XY_Mode == 1)	//X-Y mode
        {
            horz_cursor_start = DrawXYOffsetX1;
            horz_cursor_stop = DrawXYOffsetX2;
        }
        else
        {
            horz_cursor_start = 0;
            horz_cursor_stop = GRID_WIDTH;
        }
        // Draw New Horizontal Cursor
        if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
        {
            //BufVal1 = (QM_Horizontal_Position1 >> 1) + DrawOffsetY;
           // BufVal2 = (QM_Horizontal_Position2 >> 1) + DrawOffsetY;
                    /*
            if (multi_active)
            {
                BufVal1 = (int (float (QM_Horizontal_Position1) * ZeroScaleFactor[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;
                BufVal2 = (int (float (QM_Horizontal_Position2) * ZeroScaleFactor[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;

//                BufVal1 = (nm_mult(QM_Horizontal_Position1 - 128, Voltage_Correction[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;
//                BufVal2 = (nm_mult(QM_Horizontal_Position2 - 128, Voltage_Correction[0][Selected_Voltage_CH1]) >> 1) + DrawOffsetY;
            }
            else  */
            {
                BufVal1 = (QM_Horizontal_Position1 >> 1) + DrawOffsetY;
                BufVal2 = (QM_Horizontal_Position2 >> 1) + DrawOffsetY;
            }
        }
        else
        {             /*
            if (multi_active)           //QM_Horizontal_Position_Real1
            {
                BufVal1 = int (float (QM_Horizontal_Position1) * ZeroScaleFactor[0][Selected_Voltage_CH1]) + DrawOffsetY;
                BufVal2 = int (float (QM_Horizontal_Position2) * ZeroScaleFactor[0][Selected_Voltage_CH1]) + DrawOffsetY;
            }
            else        */
            {
                BufVal1 = QM_Horizontal_Position1 + DrawOffsetY;
                BufVal2 = QM_Horizontal_Position2 + DrawOffsetY;
            }
        }

        switch(QM_Horizontal_Active)
        {
            // Cursor 1 is active
            case 1:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        PIXELP(c + DrawOffsetX, BufVal1 + ((GRID_HEIGHT / 2) + 1), 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // Cursor 2 is active
            case 2:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);			

                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2 * ((GRID_HEIGHT / 2) + 1), 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);			
                    }
                }
                break;
            }
            // None Cursor is active
            case 3:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);

                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if ((c + 4) %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }	
            // Both Cursor are active
            case 4:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);

                        PIXELP(c + DrawOffsetX, BufVal1 + ((GRID_HEIGHT / 2) + 1), 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2 + ((GRID_HEIGHT / 2) + 1), 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        PIXELP(c + DrawOffsetX, BufVal1, 1, Buffer_Mark1Plane);
                        PIXELP(c + DrawOffsetX, BufVal2, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // only Cursor 1 is active
            case 5:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal1, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }
            // only Cursor 2 is active
            case 6:
            {
                if (MenuStatus[MENU_TIMEBASE][1] == 1)	//Delayed
                {
                    for (c = 0; c < GRID_WIDTH; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2 + ((GRID_HEIGHT / 2) + 1), 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                else
                {
                    for (c = horz_cursor_start; c < horz_cursor_stop; c++)
                    {
                        if (c %10 == 0) DRAWP(c + DrawOffsetX, BufVal2, 6, 1, 1, Buffer_Mark1Plane);
                    }
                }
                break;
            }                					
		}
		
		QM_Horizontal_Position1_Old = BufVal1;
		QM_Horizontal_Position2_Old = BufVal2;
		QM_Horizontal_Active_Old = QM_Horizontal_Active;
	}	                         	
		
    Cursor_Enabled_Old = Cursor_Enabled;
	QM_Enabled_Old = QM_Enabled;
	
    UpdateMarkerPlane = true;    		
}
//##########################################################################################################################################################
// BF added FFT cursor data, new two step logic
void Display::DRAWCURSORDATA(char dir)
{
	int posx = 0;
	int posy = 0;
	
	if (!CRS_Delta) return;	

	if (MenuPopupActive > -1) return;
		
	if (dir == 0)
	{	
			
		for (posy = 408 * 20; posy < 428 * 20; posy+=20)
		{
			for (posx = 0; posx < 13; posx++) *(Buffer_UI2Plane + posy + posx) = 0;		// delete Text		
		}	
	
		for (posy = 408 * 20; posy < 428 * 20; posy+=20)
		{
			for (posx = 14; posx < 20; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
		}	

		if (Cursor_Enabled)
		{
			//draw buttons
			DRAWROUNDBUTTON(1, 408, 214, 23, btnUnpushed, btnDraw);						// Button left
			DRAWROUNDBUTTON(426, 408, 214, 23, btnUnpushed, btnDraw);					// Button right	
			if (!XY_Mode) DRAWROUNDBUTTON(214, 408, 214, 23, btnUnpushed, btnDraw);				// Button middle
	
			// print text on screen
			if (XY_Mode)
			{
				TEXTOUTxvbig(Cursor_Delta_XY_X.Read_Text(), 20, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
				TEXTOUTxvbig(Cursor_Delta_Y.Read_Text(), 440, 412, 1, Buffer_UI2Plane);			// Draw Cursor Text	
			}
			else if (FFT_Mode != FFT_OFF)
			{
				TEXTOUTxvbig(FFT_Cursor_Delta_X.Read_Text(), 20, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
				TEXTOUTxvbig(FFT_Cursor_Delta_1X.Read_Text(), 230, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
				TEXTOUTxvbig(FFT_Cursor_Delta_Y.Read_Text(), 440, 412, 1, Buffer_UI2Plane);			// Draw Cursor Text	
			}
			else	// normal mode
			{
				TEXTOUTxvbig(Cursor_Delta_X.Read_Text(), 20, 412, 1, Buffer_UI2Plane);			// Draw Cursor Text	
				TEXTOUTxvbig(Cursor_Delta_1X.Read_Text(), 230, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
				TEXTOUTxvbig(Cursor_Delta_Y.Read_Text(), 440, 412, 1, Buffer_UI2Plane);			// Draw Cursor Text	
			}
	
		}
		
		Cursor_Data_First_Draw = 0;
		Cursor_Data_Draw_Pos = 0;
		CursorChanged = 0;
	}
	else
	{
		// Es fehlt noch das löschen der Textebene
		
		if (Cursor_Data_First_Draw)
		{
			DRAWROUNDBUTTON(398, 231, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 256, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 281, 214, 23, btnUnpushed, btnDraw);					// Button		
		}
		
//		TEXTOUTxvbig(Cursor_Delta_X.Read_Text(), 412, 235, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(Cursor_Delta_1X.Read_Text(), 412, 260, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(Cursor_Delta_Y.Read_Text(), 412, 285, 1, UI_Plane4);		// Draw Cursor Text	
		
		Cursor_Data_First_Draw = 0;
		Cursor_Data_Draw_Pos = 1;
	}

    UpdateMenuTextPlane = true;	
}
//##########################################################################################################################################################
// BF complete new routine with Bresenham algorithm
void Display::DRAWLINEP(int x1, int y1, int x2, int y2, char set, unsigned long *plane)	// Draw a Line
{
	
	//--------------------------------------------
	//special case horizontal line
	//--------------------------------------------
	if(y1 == y2)
	{
		if(x1 < x2)
		for(; x1 <= x2; x1++)	{ PIXELP( x1, y1, set, plane); }
		else
		for(; x2 <= x1; x2++)	{ PIXELP( x2, y1, set, plane); }
		return;
	}	

	//--------------------------------------------
	//special case vertical line
	//--------------------------------------------
	else if(x1 == x2)
	{
		if(y1 < y2)
		for(; y1 <= y2; y1++)	{ PIXELP( x1, y1, set, plane); }
		else
		for(; y2 <= y1; y2++)	{ PIXELP( x1, y2, set, plane); }
		return;
	}	

	//-------------------------------------------------------------
	// Bresenham algorithm for drawing diagonal lines
	//-------------------------------------------------------------
	int dy = y2 - y1;
        int dx = x2 - x1;
        int stepx, stepy;

	//check if delta is positive or negative
	if (dy < 0) { dy = -dy;  stepy = -1; } else { stepy = 1; }
        if (dx < 0) { dx = -dx;  stepx = -1; } else { stepx = 1; }

	//special case exact 45 degrees delta x / delta y = 1
	if (dx == dy)
	{
		//horizontal and vertical component increment constant with 1 
		if(x1 < x2) 
		{
			if(y1 < y2)
			{ 
				for(; x1 != x2; x1++, y1++)
				{ PIXELP( x1, y1, set, plane); }
				return;
			}
			else if(y1 > y2)
			{
				for(; x1 != x2; x1++, y1--)
				{ PIXELP( x1, y1, set, plane); }
				return;
			}
			
		}
		else if(x1 > x2)
		{
			if(y1 < y2) 
			{
				for(; x1 != x2; x1--, y1++)
				{ PIXELP( x1, y1, set, plane); }
				return;
			}
			else if(y1 > y2)
			{
				for(; x1 != x2; x1--, y1--)
				{ PIXELP( x1, y1, set, plane); }
				return;
			}
		}
	}

	
        dy <<= 1;                              		// dy is now 2*dy
        dx <<= 1;                              		// dx is now 2*dx
	
	//set starting point
	PIXELP( x1, y1, set, plane);
	
	//---------------------------------------------
	//between horizontal and 45 degrees
	//---------------------------------------------
	if (dx > dy)
	{
		int fraction = dy - (dx >> 1);   	// same as 2*dy - dx
		while (x1 != x2) {
			if (fraction >= 0) {
			y1 += stepy;
			fraction -= dx;              	// same as fraction -= 2*dx
			}
			x1 += stepx;
			fraction += dy;          	// same as fraction -= 2*dy
			PIXELP( x1, y1, set, plane);
		}
        	return;
	}

	//---------------------------------------------
	//between vertical and 45 degrees
	//---------------------------------------------
	if (dx < dy)
	{
		int fraction = dx - (dy >> 1);
		while (y1 != y2) {
			if (fraction >= 0) {
			x1 += stepx;
			fraction -= dy;
			}
			y1 += stepy;
			fraction += dx;
			PIXELP( x1, y1, set, plane);
		}
		return;
        }

}
//##########################################################################################################################################################

void Display::DRAWMEMORY(char remove, char firstdraw, char redraw)
{
    int intbuf = 0;
    int pos_wst = 0;
    int pos_wsp = 0;
    int pos_to = 0;

    if (remove)
    {
        DRAWP(104, 33, 430, 19, 0, UI_Plane1);									// Clear First	
        DRAWP(104, 33, 430, 19, 0, UI_Plane2);									// Clear First	
        DRAWP(104, 33, 430, 19, 0, UI_Plane4);									// Clear First	
        DRAWP(104, 33, 430, 19, 0, UI_Plane5);									// Clear First	
        DRAWP(104, 33, 430, 19, 0, Marker_Plane2);								// Clear First	
	DRAWP(104, 33, 430, 19, 0, Buffer_Mark1Plane);								// Clear First	

        Memory_Window_visible = false;
    }

    if (firstdraw)
    {
        Memory_Window_visible = true;

        DRAWROUNDBUTTON(106, 33, 430, 19, btnUnpushed, btnDraw);						// Draw Button	
        DRAWP(116, 35, 410, 13, 1, UI_Plane2);									// Clear First	

        // Testen welche genau
        //DRAWP(116, 30, 410, 13, 0, UI_Plane3);								// Clear First	
        DRAWP(116, 35, 410, 13, 0, UI_Plane4);									// Clear First	

        DRAWP(116, 35, 410, 13, 0, Marker_Plane2);								// Clear First
    }

    if (redraw)
    {
        Memory_Window_visible = true;

        if (Selected_Timebase < 7)
        {
            pos_wst = (int) (MemWinStart / 40) + 116;
            pos_wsp = (int) ((MemWinStart + SIG_Size[ZIT_short]) / 40) + 116;

            pos_to = (int) (Trig_Pos_Mem / 40) + 116;
        }
        else
        {
            pos_wst = (int) (MemWinStart / 10) + 116;
            pos_wsp = (int) ((MemWinStart + SIG_Size[ZIT_short]) / 10) + 116;

            pos_to = (int) (Trig_Pos_Mem / 10) + 116;
        }
        //BF del if (Selected_Timebase < 4) FirStartCH = MemWinStart + 40;
        
        // Remove
        // Window Start Pos
       // if (pos_wst != mb_window_start_old)
        {
            DRAWLINEP(mb_window_start_old, 36, mb_window_start_old, 47, 0, UI_Plane5);
            DRAWLINEP(mb_window_start_old, 36, mb_window_start_old, 47, 1, UI_Plane2);
        }

        // Window Stop Pos
      //  if (pos_wsp != mb_window_stop_old)
        {
            DRAWLINEP(mb_window_stop_old, 36, mb_window_stop_old, 47, 0, UI_Plane5);
            DRAWLINEP(mb_window_stop_old, 36, mb_window_stop_old, 47, 1, UI_Plane2);
        }

        // Trigger Pos
      //  if (pos_to != mb_window_trigger_old)
        {
//            DRAWLINEP(pos_to, 34, pos_to, 39, 0, Buffer_Mark1Plane);
//            DRAWLINEP(pos_to - 2, 34, pos_to + 3, 34, 0, Buffer_Mark1Plane);
            DRAWLINEP(mb_window_trigger_old, 39, mb_window_trigger_old, 44, 0, Marker_Plane2);
            DRAWLINEP(mb_window_trigger_old - 2, 39, mb_window_trigger_old + 3, 39, 0, Marker_Plane2);
            DRAWLINEP(mb_window_trigger_old, 39, mb_window_trigger_old, 44, 1, UI_Plane2);
            DRAWLINEP(mb_window_trigger_old - 2, 39, mb_window_trigger_old + 3, 39, 1, UI_Plane2);

            if (mb_window_trigger_old < 119)
            {
                DRAWP(113, 39, 3, 5, 0, Marker_Plane2);
                DRAWP(113, 39, 3, 5, 0, UI_Plane2);
            }
            if (mb_window_trigger_old > 522)
            {
                PIXELP(526, 39, 0, Marker_Plane2);
                PIXELP(526, 39, 0, UI_Plane2);
            }
        }


        // Redraw

        // Window Start Pos
        DRAWLINEP(pos_wst, 36, pos_wst, 47, 1, UI_Plane5);
        DRAWLINEP(pos_wst, 36, pos_wst, 47, 0, UI_Plane2);
        mb_window_start_old = pos_wst;

        // Window Stop Pos
        DRAWLINEP(pos_wsp, 36, pos_wsp, 47, 1, UI_Plane5);
        DRAWLINEP(pos_wsp, 36, pos_wsp, 47, 0, UI_Plane2);
        mb_window_stop_old = pos_wsp;

        // Trigger Pos
        DRAWLINEP(pos_to, 39, pos_to, 44, 1, Marker_Plane2);
        DRAWLINEP(pos_to - 2, 39, pos_to + 3, 39, 1, Marker_Plane2);
        DRAWLINEP(pos_to, 39, pos_to, 44, 0, UI_Plane2);
        DRAWLINEP(pos_to - 2, 39, pos_to + 3, 39, 0, UI_Plane2);
        DRAWLINEP(pos_to, 39, pos_to, 44, 0, UI_Plane5);
        DRAWLINEP(pos_to - 2, 39, pos_to + 3, 39, 0, UI_Plane5);
        mb_window_trigger_old = pos_to;
    }

    //UpdateMarkerPlane = true;
}
//##########################################################################################################################################################

void Display::DRAWMENUBUTTONSELECT(int buttonnr)
{
	int x, y, c, posx = 0;
	posx = 40 + (buttonnr * 100);
	
	c = 21;	
	for (y = 0; y < 10; y++)
	{
		for (x = 0; x < c; x++)
		{
			if (x == 0) PIXELP(posx + y + x, 420 + y, 1, UI_Plane5);				//clBlack
			else if (x == (c - 1)) PIXELP(posx + y + x, 420 + y, 1, UI_Plane5);
			else PIXELP(posx + y + x, 420 + y, 1, UI_Plane4);		
			PIXELP(posx + y + x, 420 + y, 0, UI_Plane2);
		}
		c--;
		c--;
	}	
 }
//##########################################################################################################################################################

void Display::DRAWMENUPOPDOWN(void)
{
	int x, y;
	int posy = 0;
	int sizey = 0;
	int count = 0;	
	int xa, xo, Ct;	

	// Clean Up the Popup
	xa = MenuPopupY * 20;
	xo = MenuPopupX / 32;

	for (Ct = 0; Ct < MenuPopupSizeY - 5; Ct++)
	{			
		*(UI_Plane1 + xo + xa)     = 0;
		*(UI_Plane1 + xo + xa + 1) = 0;
		*(UI_Plane1 + xo + xa + 2) = 0;
		*(UI_Plane1 + xo + xa + 3) = 0;
		*(UI_Plane1 + xo + xa + 4) = 0;
		*(UI_Plane1 + xo + xa + 5) = 0;

		*(Buffer_UI2Plane + xo + xa)     = 0;
		*(Buffer_UI2Plane + xo + xa + 1) = 0;
		*(Buffer_UI2Plane + xo + xa + 2) = 0;
		*(Buffer_UI2Plane + xo + xa + 3) = 0;
		*(Buffer_UI2Plane + xo + xa + 4) = 0;
		*(Buffer_UI2Plane + xo + xa + 5) = 0;

		*(UI_Plane2 + xo + xa)     = 0;
		*(UI_Plane2 + xo + xa + 1) = 0;
		*(UI_Plane2 + xo + xa + 2) = 0;
		*(UI_Plane2 + xo + xa + 3) = 0;
		*(UI_Plane2 + xo + xa + 4) = 0;
		*(UI_Plane2 + xo + xa + 5) = 0;
/* BF del to avoid overwriting of grid 
		*(UI_Plane3 + xo + xa)     = 0;
		*(UI_Plane3 + xo + xa + 1) = 0;
		*(UI_Plane3 + xo + xa + 2) = 0;
		*(UI_Plane3 + xo + xa + 3) = 0;
		*(UI_Plane3 + xo + xa + 4) = 0;
		*(UI_Plane3 + xo + xa + 5) = 0;
 BF end*/
		*(UI_Plane4 + xo + xa)     = 0;
		*(UI_Plane4 + xo + xa + 1) = 0;
		*(UI_Plane4 + xo + xa + 2) = 0;
		*(UI_Plane4 + xo + xa + 3) = 0;
		*(UI_Plane4 + xo + xa + 4) = 0;
		*(UI_Plane4 + xo + xa + 5) = 0;

		*(UI_Plane5 + xo + xa)     = 0;
		*(UI_Plane5 + xo + xa + 1) = 0;
		*(UI_Plane5 + xo + xa + 2) = 0;
		*(UI_Plane5 + xo + xa + 3) = 0;
		*(UI_Plane5 + xo + xa + 4) = 0;
		*(UI_Plane5 + xo + xa + 5) = 0;
		xa += 20;
	}
	
/* BF del because no repair is needed when lines above are commented out
	// Repaire Menu Down
//	xa = 407 * 20;
	xa = BOTT_PLANE_MIN;
	for (Ct = 0; Ct < 23; Ct++)
	{			
		*(UI_Plane3 + xo + xa)     = 0xFFFFFFFF;
		*(UI_Plane3 + xo + xa + 1) = 0xFFFFFFFF;
		*(UI_Plane3 + xo + xa + 2) = 0xFFFFFFFF;
		*(UI_Plane3 + xo + xa + 3) = 0xFFFFFFFF;
		*(UI_Plane3 + xo + xa + 4) = 0xFFFFFFFF;
		*(UI_Plane3 + xo + xa + 5) = 0xFFFFFFFF;
		xa += 20;
	}	
BF end */

	if (MenuPopupActive == 4)
    	{
		// Repaire Top Menu
		xa = 9 * 20;
		for (Ct = 0; Ct < 9; Ct++)
		{			
			*(UI_Plane3 + xo + xa)     = 0xFFFFFFFF;
			*(UI_Plane3 + xo + xa + 1) = 0xFFFFFFFF;
			*(UI_Plane3 + xo + xa + 2) = 0xFFFFFFFF;
			*(UI_Plane3 + xo + xa + 3) = 0xFFFFFFFF;
			*(UI_Plane3 + xo + xa + 4) = 0xFFFFFFFF;
			*(UI_Plane3 + xo + xa + 5) = 0xFFFFFFFF;
			xa += 20;
		}

	/* TMW  if (MenuStatus[5][4] == 241)	//Units
		{
		Display::DRAWMEMORY(0, 1, 1);
		} TMW*/
	
	//        Channel_2_Active = 1;
		VoltageChangedCh1 = 1;
		VoltageChangedCh2 = 1;
	
		Channel_1_Active_Old = 0;
		Channel_2_Active_Old = 0;
	
		if (NumberOfChannels > 2)
		{
		//            Channel_3_Active = 1;
			VoltageChangedCh3 = 1;
		
		//            Channel_4_Active = 1;
			VoltageChangedCh4 = 1;
		
			Channel_3_Active_Old = 0;
			Channel_4_Active_Old = 0;
		}
	
		StatusUpdate();
    	}
	

	MenuPopupActive = -1;
	MenuPopupChanged = 0;
	New_Menu = Active_Menu;
    	Menu_Changed = 1;

	// Repaire Menu	
	if (Cursor_Enabled)
	{
		CursorChanged = 3;
		Cursor_Data_First_Draw = true;
		DRAWCURSORDATA(0);
	}
	if (QM_Enabled)
	{
		Quick_Measure_First_Draw = true;
		DRAWQMDATA(0);
	}
	
  
//    Hardware::TransferDataPlane_asm_persistant(0x008DBB24, 0x00970F30);
//    UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################

void Display::DRAWMENUPOPUP(int PopupNr)
{
	int x, xe, y;
	int pos = 0;

	int posx = 0;
	int sizex = 0;
	int posy = 0;
	int sizey = 0;
	int count = 0;	
	int button = 0;
	
	char BufferText[22];
	char BufferText2[22];	
		
	button = MenuPopupDef[PopupNr][0];
	count  = MenuPopupDef[PopupNr][1];
	
	posx = (button * 100) + 15;
	sizey = (count * 17) + 37;
	posy = 420 - sizey;

	if ((PopupNr == 4) || (PopupNr == 22)) sizex = 150;
	else sizex = 120;

	MenuPopupX = posx - 2;
	MenuPopupY = posy;
	MenuPopupSizeX = sizex + 4;
	MenuPopupSizeY = sizey + 15;

	// Clear


	if (MenuPopupActive != PopupNr)
	{
		DRAWP(posx - 1, posy, sizex + 2, sizey, 0, UI_Plane1); //sizey = 5	
		DRAWP(posx - 1, posy, sizex + 2, sizey, 0, UI_Plane2);
		DRAWP(posx - 1, posy, sizex + 2, sizey, 0, UI_Plane5);		
	
		DRAWROUNDBUTTON(posx - 3, posy, sizex + 6, sizey + 3, btnUnpushed, btnDraw);
		DRAWMENUBUTTONSELECT(button);		

		//Draw Popup Caption
		sprintf(BufferText, "");
		for (xe = 0; xe < 20; xe++)
		{
			BufferText[xe] = MenuPopupText[PopupNr][0][xe];
		}
		TEXTOUTxvbig(BufferText, posx + 5, posy + 5, 1, UI_Plane2);					// Draw Menu Text
		
		// Div Line
		DRAWP(posx + 2, posy + 20, sizex - 4, 1, 1, UI_Plane5);
		DRAWP(posx + 2, posy + 21, sizex - 4, 1, 1, UI_Plane1);	
		
		for (x = 0;x < count;x++)
		{
			sprintf(BufferText, "");
			for (xe = 0; xe < 20; xe++)
			{
				BufferText[xe] = MenuPopupText[PopupNr][x + 1][xe];
			}
		
			if (MenuPopupStatus[PopupNr][x] == 1)
			{
	//			TEXTOUTxvbig(BufferText, posx + 25, posy + 28 + (x * 17), 0, UI_Plane2);	// Draw Popup Item Text
				TEXTOUTxvbig(BufferText, posx + 25, posy + 28 + (x * 17), 1, UI_Plane5);	// Draw Popup Item Text	
			}
			else if (MenuPopupStatus[PopupNr][x] == 2)
			{
				TEXTOUTxvbig(BufferText, posx + 25, posy + 28 + (x * 17), 1, UI_Plane2);	// Draw Popup Item Text
			}
			else if (MenuPopupStatus[PopupNr][x] == 3)
			{
				sprintf(BufferText2, "%c  %s", Menu_Select, BufferText);
				TEXTOUTxvbig(BufferText2, posx + 5, posy + 28 + (x * 17), 1, UI_Plane2);	// Draw Popup Item Text		
			}			
		}
	}
	else
	{
		DRAWP(posx + 4, posy + 27, 15, sizey - 35, 0, UI_Plane2);
		
		for (x = 0;x < count;x++)
		{		
			if (MenuPopupStatus[PopupNr][x] == 3)
			{
				sprintf(BufferText2, "%c", Menu_Select);
				TEXTOUTxvbig(BufferText2, posx + 5, posy + 28 + (x * 17), 1, UI_Plane2);	// Draw Popup Item Text		
			}
		}
	}		
		
	MenuPopupChanged = 1;
	MenuPopupActive  = PopupNr;	
	
//	MenuTimeCounter = 0;
	//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
}
//##########################################################################################################################################################
//BF -> draw rectangle??
void Display::DRAWP(int x, int y, int dx, int dy, char set, unsigned long *planeaddress)
{
	int pos;
	int bit;
	int bitbuf;
	int intbuf;
	long BitMaskBuf;
	
	int ctx, cty;
		
	intbuf = (x >> 5);	
	
	bit = (x - (intbuf << 5));
	bitbuf = bit;
		
	for (cty = y; cty < (y + dy); cty++)
	{
		bit = bitbuf;
		if (set == 1) BitMaskBuf = BitMasks2[bit];
		else BitMaskBuf = BitMasks[bit];
		
		pos = (cty * 20) + intbuf;
				
		for (ctx = dx; ctx > 0; ctx--)
		{
			if (set == 1)
			{
				*(planeaddress + pos) = *(planeaddress + pos) | BitMaskBuf;
				BitMaskBuf >>= 1;
			}
			else
			{
				*(planeaddress + pos) = *(planeaddress + pos) & BitMaskBuf;
				BitMaskBuf >>= 1;
				BitMaskBuf |= 0x80000000;				
			}			
		
			bit++;
			
			if (bit > 31)
			{
				bit = 0;
				pos++;
				if (set == 1) BitMaskBuf = 0x80000000;
				else BitMaskBuf = 0x7FFFFFFF;
			}
		}		
	}	
}
//##########################################################################################################################################################

void Display::DRAWQMDATA(char dir)
{
	int posx = 0;
	int posy = 0;
	
	if (MenuPopupActive > -1) return;
	
	if (dir == 0)
	{			
		if (Quick_Measure_First_Draw)
		{
            // remove the cursor data
            for (posx = 408 * 20; posx < 430 * 20; posx++)
            {
                *(UI_Plane1 + posx) = 0;	// delete
                *(Buffer_UI2Plane + posx) = 0;	// delete Text				
                *(UI_Plane4 + posx) = 0;	// delete
                *(UI_Plane5 + posx) = 0;	// delete
            }
        }
        else		
        {
            if (QM_Changed[0] == 1)
            {
                for (posy = 408 * 20; posy < 428 * 20; posy+=20)
                {
                    for (posx = 0; posx < 6; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
                }
            }
            if (QM_Changed[1] == 1)
            {
                for (posy = 408 * 20; posy < 428 * 20; posy+=20)
                {
                    for (posx = 6; posx < 13; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
                }
            }
            if (QM_Changed[2] == 1)     // Muß größe des löschbereichs noch getestet werden
            {
                for (posy = 408 * 20; posy < 428 * 20; posy+=20)
                {
                    for (posx = 14; posx < 19; posx++) *(Buffer_UI2Plane + posy + posx) = 0;	// delete Text		
                }
            }
		}

        if (QM_Enabled)
        {		
            if (Quick_Measure_First_Draw)
            {
                if (QM_Type[0] > 0) DRAWROUNDBUTTON(1, 408, 214, 23, btnUnpushed, btnDraw);					// Button
                if (QM_Type[1] > 0) DRAWROUNDBUTTON(214, 408, 214, 23, btnUnpushed, btnDraw);					// Button
                if (QM_Type[2] > 0) DRAWROUNDBUTTON(426, 408, 214, 23, btnUnpushed, btnDraw);					// Button	
            }
	
            if (QM_Type[0] > 0) TEXTOUTxvbig(QM_Slot1.Read_Text(), 20, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
            if (QM_Type[1] > 0) TEXTOUTxvbig(QM_Slot2.Read_Text(), 230, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
            if (QM_Type[2] > 0) TEXTOUTxvbig(QM_Slot3.Read_Text(), 440, 412, 1, Buffer_UI2Plane);		// Draw Cursor Text	
        }
		
		Quick_Measure_First_Draw = 0;
		Quick_Measure_Data_Draw_Pos = 0;
		if (QM_Type[0] > 0) QM_Changed[0] = 0;
		if (QM_Type[1] > 0) QM_Changed[1] = 0;
		if (QM_Type[2] > 0) QM_Changed[2] = 0;
	}
	else
	{
		// Es fehlt noch das löschen der Textebene
		
		if (Cursor_Data_First_Draw)
		{
			DRAWROUNDBUTTON(398, 231, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 256, 214, 23, btnUnpushed, btnDraw);					// Button
			DRAWROUNDBUTTON(398, 281, 214, 23, btnUnpushed, btnDraw);					// Button		
		}
		
//		TEXTOUTxvbig(QM_Slot1.Read_Text(), 412, 235, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(QM_Slot2.Read_Text(), 412, 260, 1, UI_Plane4);		// Draw Cursor Text
//		TEXTOUTxvbig(QM_Slot3.Read_Text(), 412, 285, 1, UI_Plane4);		// Draw Cursor Text	
		
		Quick_Measure_First_Draw = 0;
		Quick_Measure_Data_Draw_Pos = 1;
		if (QM_Type[0] > 0) QM_Changed[0] = 0;
		if (QM_Type[1] > 0) QM_Changed[1] = 0;
		if (QM_Type[2] > 0) QM_Changed[2] = 0;
	}    	
/* ???	
    QM_Type_Old[0] = QM_Type[0];
    QM_Type_Old[1] = QM_Type[1];
    QM_Type_Old[2] = QM_Type[2];	
 */
    UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################
//BF  added workaround for wrong UI_Plane1 transfer	
void Display::DRAWROUNDBUTTON(int posx, int posy, int sizex, int sizey, unsigned char pushed, unsigned char remove)
{
	char set;
	unsigned long *iplane;	
	int x, y, c;
	
	pushed = 0;	// BF test
	
	if (remove) set = 0;
	else set = 1;		
		
	// Upper side
	// Left Edge
	c = 8;
	for (y = 1; y < 7; y++)
	{
		if (y < 6) c--;	
		for (x = c; x < 9; x++)
		{
			if ((y == 1) && (pushed == 0)) iplane = UI_Plane1;
			else if ((y == 1) && (pushed == 1)) iplane = UI_Plane5;
			else if ((x == c) && (pushed == 0)) iplane = UI_Plane1;
			else if ((x == c) && (pushed == 1)) iplane = UI_Plane5;
			else iplane = UI_Plane4;
			
			PIXELP(posx + x, posy + y, set, iplane);
		}
	}

/*BF  del -> workaround for wrong UI_Plane1 transfer	
	if (pushed) iplane = UI_Plane5;
	else iplane = UI_Plane1;	
	
	// Upper Middle
	DRAWP(posx + 9, posy, sizex - 18, 1, set, iplane);		// TopLine
*/
	if ((posx+sizex) > 607)	//BF workaround for wrong UI_Plane1 transfer	
	{
		DRAWLINEP(posx + 9, posy, posx + sizex - 9, posy, set, UI_Plane4);	// top line
		DRAWLINEP(posx + 9, posy, 607, posy, set, UI_Plane1);			// top line

	}	
	else
	DRAWLINEP(posx + 9, posy, posx + sizex - 9, posy, set, UI_Plane1);		// top line


	// Middle Block
	DRAWP(posx + 9, posy + 1, sizex - 18, 6, set, UI_Plane4);

	// Right Edge
	c = 1;
	for (y = 1; y < 7; y++)
	{
		if (y < 6) c++;	
		for (x = 0; x < c; x++)
		{	
			if ((y == 1) && (pushed == 0)) 
			{ if ((posx+sizex) > 607) iplane = UI_Plane4;	else iplane = UI_Plane1; }	//BF workaround for wrong UI_Plane1 transfer	
			else if ((y == 1) && (pushed == 1)) iplane = UI_Plane5;
			else if ((x == (c - 1)) && (pushed == 0))		
			{ if ((posx+sizex) > 607) iplane = UI_Plane4;	else iplane = UI_Plane1; }	//BF workaround for wrong UI_Plane1 transfer	
			else if ((x == (c - 1)) && (pushed == 1)) iplane = UI_Plane5;
			else iplane = UI_Plane4;
			
			PIXELP(posx + (sizex - 9) + x, posy + y, set, iplane);
		}
	}		

	// Middle Block
	DRAWP(posx + 3, posy + 7, sizex - 6, sizey - 16, set, UI_Plane4);

	// Sidelines
	if (pushed)
	{
		DRAWP(posx + 2, posy + 7, 1, sizey - 16, set, UI_Plane5);
		DRAWP(posx + sizex - 3, posy + 7, 1, sizey - 16, set, UI_Plane1);
	}
	else
	{
		DRAWP(posx + 2, posy + 7, 1, sizey - 16, set, UI_Plane1);
		DRAWP(posx + sizex - 3, posy + 7, 1, sizey - 16, set, UI_Plane5);
	}

	// Down
	// Left Edge
	c = 3;
	for (y = 0; y < 6; y++)
	{
		if (y > 1) c++;	
		for (x = c; x < 9; x++)
		{		
			if ((y == 5) && (pushed == 0)) iplane = UI_Plane5;
			else if ((y == 5) && (pushed == 1)) iplane = UI_Plane1;
			else if ((x == c) && (pushed == 0)) iplane = UI_Plane5;
			else if ((x == c) && (pushed == 1)) iplane = UI_Plane1;
			else iplane = UI_Plane4;			
			
			PIXELP(posx + x, posy + (sizey - 9) + y, set, iplane);
		}
	}

	if (pushed) iplane = UI_Plane1;
	else iplane = UI_Plane5;
	
	// Lower Middle
	DRAWP(posx + 9, posy + (sizey - 9) + 6, sizex - 18, 1, set, iplane);	// BottomLine

	// Middle Block
	DRAWP(posx + 9, posy + (sizey - 9), sizex - 18, 6, set, UI_Plane4);

	// Right Edge
	c = 6;
	for (y = 0; y < 6; y++)
	{
		if (y > 1) c--;	
		for (x = 0; x < c; x++)
		{		
			if ((y == 5) && (pushed == 0)) iplane = UI_Plane5;
			else if ((y == 5) && (pushed == 1)) iplane = UI_Plane1;
			else if ((x == (c - 1)) && (pushed == 0)) iplane = UI_Plane5;
			else if ((x == (c - 1)) && (pushed == 1)) iplane = UI_Plane1;
			else iplane = UI_Plane4;						
			
			PIXELP(posx + (sizex - 9) + x, posy + (sizey - 9) + y, set, iplane);
		}
	}
}
//##########################################################################################################################################################

// Draw Time Signal on T-Y axis		BF -> complete new drawing routine for all time signals incl. delayed signals
void Display::DRAWSIGNAL_TY(unsigned int channel, unsigned char windows, unsigned int timefactor, unsigned int ixstart, unsigned char *DisplayData, unsigned char on, unsigned char vector)
{
	int   ZeroLevel = 0;
//	int   alpha_cor = 0;
//	float beta_cor  = 1;

	unsigned long *plane = NULL;

	short P1 = 0;
	short P2 = 0;
	short P3 = 0;	

	short factor_buff = timefactor;	
	short display_min;
	short display_max;
	
	int   lix = 0; 			//signal index
	int   lposx = 0;		//grid position

	int lscale_int_factor = 1, lscale_shift_factor = 1;
	unsigned char ldmode = 0, lInterpol = 0;



/*
printf("\r\n-----------------------------------------------------------\r\n");
printf("channel                 = %d\r\n", channel);
printf("Selected_Timebase       = %d\r\n", Selected_Timebase);
printf("dmode_Selected_Timebase = %d\r\n", dmode_Selected_Timebase);
printf("factor                  = %d\r\n", factor);
printf("offset                  = %d\r\n", offset);
printf("Trigger_Offset_Calc     = %d\r\n", TOC_Buf);
printf("windows                 = %d\r\n", windows);
printf("on                      = %d\r\n", on);
printf("vector                  = %d\r\n", vector);
*/



	if (MenuStatus[10][1] == 1)	//Delayed mode
	ldmode = 1;
	else
	ldmode = 0;

	//----------------------------------------
	//set channel depending parameters
	//----------------------------------------
	if (channel == 1)
	{	
		plane = Buffer_Plane1;			// pointer to display layer
		//pix  = &SIGNAL1_SUM_MIN[0];		// pointer to signal buffer (1200 byte)
		//pix2 = &SIGNAL1_SUM_MAX[0];		// pointer to signal buffer (1200 byte)
		//ZeroLevel = ZeroLevelCH1 + GRID_YOFFS;	//without zero shift
		ZeroLevel = (GRID_HEIGHT / 2) + GRID_YOFFS;	//with zero shift the draw zero is in the middle of the grid
		
		//Calculate scaling factor
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH1];
		lscale_shift_factor = scale_shift_factor[ldmode][Selected_Voltage_CH1];

	}	

	if (channel == 2)
	{	
		plane = Buffer_Plane2;			//Channel_Plane2;
		//pix  = &SIGNAL2_SUM_MIN[0];
		//pix2 = &SIGNAL2_SUM_MAX[0];	
		//ZeroLevel = ZeroLevelCH2 + GRID_YOFFS;		
		ZeroLevel = (GRID_HEIGHT / 2) + GRID_YOFFS;	//with zero shift the draw zero is in the middle of the grid
		
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH2];
		lscale_shift_factor = scale_shift_factor[ldmode][Selected_Voltage_CH2];
 
	}
	
	if (channel == 3)
	{		
		plane = Buffer_Plane3;			//Channel_Plane3;
		//pix  = &SIGNAL3_SUM_MIN[0];
		//pix2 = &SIGNAL3_SUM_MAX[0];	
		//ZeroLevel = ZeroLevelCH3 + GRID_YOFFS;		
		ZeroLevel = (GRID_HEIGHT / 2) + GRID_YOFFS;	//with zero shift the draw zero is in the middle of the grid
		
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH3];
		lscale_shift_factor = scale_shift_factor[ldmode][Selected_Voltage_CH3];

	}
	
	if (channel == 4)
	{	
		plane = Buffer_Plane4;			//Channel_Plane4;
		//pix  = &SIGNAL4_SUM_MIN[0];
		//pix2 = &SIGNAL4_SUM_MAX[0];	
		//ZeroLevel = ZeroLevelCH4 + GRID_YOFFS;		
		ZeroLevel = (GRID_HEIGHT / 2) + GRID_YOFFS;	//with zero shift the draw zero is in the middle of the grid
		
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH4];
		lscale_shift_factor = scale_shift_factor[ldmode][Selected_Voltage_CH4];

	}		
	if (channel == 5)	//Math
	{	
		plane     = Buffer_PlaneM;			//Channel_Plane Math;
		//pix       = &SIGNALM_SUM_MIN[0];
		//pix2      = &SIGNALM_SUM_MAX[0];	
		
		if (Math_Offset < 0)
		{ Math_Offset *= -1;
		  ZeroLevel = GRID_YOFFS + (GRID_HEIGHT / 2) + (Math_Offset / math_voltage_div[math_scale]); }
		else
		{ ZeroLevel = GRID_YOFFS + (GRID_HEIGHT / 2) - (Math_Offset / math_voltage_div[math_scale]); }

//BF to check!!!!!!!!!!
		lscale_int_factor   = scale_int_factor[math_scale];
		lscale_shift_factor = scale_shift_factor[ldmode][math_scale];

//-------------------

	}


	//----------------------------------
	//Set drawing parameters
	//----------------------------------
	if (ldmode)	//Delayed mode
	{
		//scaling factor for delayed mode
		lscale_int_factor = 1;
				
		if (windows == 1)	//draw main signal into upper delayed grid area
		{
			ZeroLevel = ((ZeroLevel - GRID_YOFFS) >> 1) + GRID_YOFFS;
			
			display_min = GRID_YOFFS;
			display_max = ((GRID_HEIGHT >> 1) - 2) + GRID_YOFFS;
		}
		else	//draw delayed signal into bottom grid area
		{
			ZeroLevel = ((ZeroLevel - GRID_YOFFS) >> 1) + (GRID_HEIGHT / 2) + GRID_YOFFS;
			
			display_min = ((GRID_HEIGHT >> 1) + 2) + GRID_YOFFS;
			display_max = GRID_HEIGHT + GRID_YOFFS;
		}
	}
	else	//Main mode
	{
		display_min = GRID_YOFFS;
		display_max = GRID_HEIGHT + GRID_YOFFS;	
	}

	//factor (time factor) is the step width of the loop index and must be minimum 1
	if(timefactor <= 0)
	{ timefactor = 1; }


//--------------------------------------------------------------------------------------------------------
//                         Signal drawing with vector or points
//--------------------------------------------------------------------------------------------------------

	
	//-----------------------------------------------------------
	// pixel connection drawing routine - fastest drawing
	//-----------------------------------------------------------
	if(!draw_mode)
	{
		lposx = GRID_XOFFS;
		lix   = ixstart;	//get index offset
	
		if(vector)	
		{
			//Get ADC-value of starting point and calculate correction
			P2 = (short) (DisplayData[lix] - ADC_ZERO);
			lix += timefactor;
			P3 = (short) (DisplayData[lix] - ADC_ZERO);
			
			//scaling and Y-positioning of starting points
			//P2 = (short)(ZeroLevel + (P2 * lscale_int_factor) + (P2 >> lscale_shift_factor));
			//P3 = (short)(ZeroLevel + (P3 * lscale_int_factor) + (P3 >> lscale_shift_factor));

			if(lscale_int_factor == 1)
			{
				P2 = (short)(ZeroLevel + P2 + (P2 >> lscale_shift_factor));
				P3 = (short)(ZeroLevel + P3 + (P3 >> lscale_shift_factor));
			}
			else if(lscale_int_factor == 2)
			{
				P2 = (short)(ZeroLevel + (P2 << 1) + (P2 >> lscale_shift_factor));
				P3 = (short)(ZeroLevel + (P3 << 1) + (P3 >> lscale_shift_factor));
			}
			else 	// -> 3
			{
				P2 = (short)(ZeroLevel + P2 + (P2 << 1) + (P2 >> lscale_shift_factor));
				P3 = (short)(ZeroLevel + P3 + (P3 << 1) + (P3 >> lscale_shift_factor));
			}

			//limiter
			if (P2 > display_max) P2 = display_max;
			if (P2 < display_min) P2 = display_min;
			if (P3 > display_max) P3 = display_max;
			if (P3 < display_min) P3 = display_min;
		
			//draw signal
			for (lix += timefactor; (lposx - GRID_XOFFS) < GRID_WIDTH-1; lix += timefactor)
			{
				lposx++;
		
				P1 = P2;
				P2 = P3;		
				//get next ADC-value
				P3 = (short)(DisplayData[lix] - ADC_ZERO);
	
				//scaling and Y-positioning
				//P3 = (short)(ZeroLevel + (P3 * lscale_int_factor) + (P3 >> lscale_shift_factor));
				
				if(lscale_int_factor == 1)
				{ P3 = (short)(ZeroLevel + P3 + (P3 >> lscale_shift_factor)); }
				else if(lscale_int_factor == 2)
				{ P3 = (short)(ZeroLevel + (P3 << 1) + (P3 >> lscale_shift_factor)); }
				else 	// -> 3
				{ P3 = (short)(ZeroLevel + P3 + (P3 << 1) + (P3 >> lscale_shift_factor)); }

				//limiter
				if (P3 > display_max) P3 = display_max;
				if (P3 < display_min) P3 = display_min;
		
				//-----------------------------------------------------------
				//		Draw lines
				//-----------------------------------------------------------
				//Fall 1   ( 1 == 2 == 3 )
				if ((P1 == P2) && (P2 == P3))
				{ PIXELP(lposx, P1, on, plane); }
		
				//Fall 2   ( 1 < 2 < 3 )
				else if ((P1 < P2) && (P2 < P3))
				{ Connect_Pixels(lposx, P1, P2, 1, plane, on); }	
			
				//Fall 3   ( 1 > 2 > 3 )
				else if ((P1 > P2) && (P2 > P3))
				{ Connect_Pixels(lposx, P1, P2, 0, plane, on); }	
			
				//Fall 4   ( 1 < 2 = 3 )
				else if ((P1 < P2) && (P2 == P3))
				{ Connect_Pixels(lposx, P1, P2, 1, plane, on); }	
				
				//Fall 5   ( 1 > 2 = 3 )
				else if ((P1 > P2) && (P2 == P3))
				{ Connect_Pixels(lposx, P1, P2, 0, plane, on); }
				
				//Fall 6   ( 1 = 2 < 3 )
				else if ((P1 == P2) && (P2 < P3))
				{ PIXELP(lposx, P1, on, plane); }	
				
				//Fall 7   ( 1 = 2 > 3 )
				else if ((P1 == P2) && (P2 > P3))
				{ PIXELP(lposx, P1, on, plane); }	
			
				//Fall 8   ( 1 > 2 < 3 )
				else if ((P1 > P2) && (P2 < P3))
				{ Connect_Pixels(lposx, P1, P2, 0, plane, on); }	
				
				//Fall 9   ( 1 < 2 > 3 )
				else if ((P1 < P2) && (P2 > P3))
				{ Connect_Pixels(lposx, P1, P2, 1, plane, on); }	
				else //-> Fall 1
				{ PIXELP(lposx, P1, on, plane); }	
			}	
	
		}
		else
		{
		//+++++++++++++ draw only single points +++++++++++++
		//BF -> in interpolated TB drop the interpolated values

			if (Selected_Timebase == 3)
			lInterpol = 2;
			else if (Selected_Timebase == 2)
			lInterpol = 4;
			else if (Selected_Timebase == 1)
			lInterpol = 9;
			else if (Selected_Timebase == 0)
			lInterpol = 24;
			else
			lInterpol = 0;

			char ip;

			for (ip=0,lix += timefactor; (lposx - GRID_XOFFS) < (GRID_WIDTH-1); lix += timefactor, ip--)
			{
				lposx++;
		
				if (ip<=0)
				{
					if (lInterpol == 2)	//toggle faktor between 1 and 2 to simulate 1,5
					lInterpol = 1;
					if (lInterpol == 1)
					lInterpol = 2;
 
					ip = lInterpol;

					P1 = (short) (DisplayData[lix] - ADC_ZERO);
		
					//P1 = (short)(ZeroLevel + int(P1 * lscal_fact));	
					//BF new int scaling
					//P1 = (short)(ZeroLevel + (P1 * lscale_int_factor) + (P1 >> lscale_shift_factor));
					if(lscale_int_factor == 1)
					{ P1 = (short)(ZeroLevel + P1 + (P1 >> lscale_shift_factor)); }
					else if(lscale_int_factor == 2)
					{ P1 = (short)(ZeroLevel + (P1 << 1) + (P1 >> lscale_shift_factor)); }
					else 	// -> 3
					{ P1 = (short)(ZeroLevel + P1 + (P1 << 1) + (P1 >> lscale_shift_factor)); }
	
					if (P1 > display_max) P1 = display_max;
					if (P1 < display_min) P1 = display_min;
				
					PIXELP(lposx, P1, on, plane);
				}
			}
		}
	
	}


	//---------------------------------------------------------------------
	// Line drawing with standard line function - 
	// new line() function which is as fast as the pixel connection 
	// routine but shows more details
	//---------------------------------------------------------------------
	if(draw_mode)	
	{
		
		lposx = GRID_XOFFS;
		lix   = ixstart;	//get index offset
		if(vector)	
		{
		//+++++++++++++++++ draw signal as vector line ++++++++++++++++++
	
			//Get ADC-value of starting point and calculate correction
			P2 = (short) (DisplayData[lix] - ADC_ZERO);
			lix += timefactor;
			P3 = (short) (DisplayData[lix] - ADC_ZERO);
			
			//scaling and Y-positioning of starting points
			//P2 = (short)(ZeroLevel + (P2 * lscale_int_factor) + (P2 >> lscale_shift_factor));
			//P3 = (short)(ZeroLevel + (P3 * lscale_int_factor) + (P3 >> lscale_shift_factor));
			
			if(lscale_int_factor == 1)
			{
				P2 = (short)(ZeroLevel + P2 + (P2 >> lscale_shift_factor));
				P3 = (short)(ZeroLevel + P3 + (P3 >> lscale_shift_factor));
			}
			else if(lscale_int_factor == 2)
			{
				P2 = (short)(ZeroLevel + (P2 << 1) + (P2 >> lscale_shift_factor));
				P3 = (short)(ZeroLevel + (P3 << 1) + (P3 >> lscale_shift_factor));
			}
			else 	// -> 3
			{
				P2 = (short)(ZeroLevel + P2 + (P2 << 1) + (P2 >> lscale_shift_factor));
				P3 = (short)(ZeroLevel + P3 + (P3 << 1) + (P3 >> lscale_shift_factor));
			}
			
			//limiter
			if (P2 > display_max) P2 = display_max;
			if (P2 < display_min) P2 = display_min;
			if (P3 > display_max) P3 = display_max;
			if (P3 < display_min) P3 = display_min;

			//draw signal
			for (lix += timefactor; (lposx - GRID_XOFFS) < GRID_WIDTH-1; lix += timefactor)
			{
				lposx++;
		
				//P1 = P2;
				P2 = P3;		
				//get next ADC-value
				P3 = (short)(DisplayData[lix] - ADC_ZERO);
	
				//scaling and Y-positioning
				//P3 = (short)(ZeroLevel + (P3 * lscale_int_factor) + (P3 >> lscale_shift_factor));
				if(lscale_int_factor == 1)
				{ P3 = (short)(ZeroLevel + P3 + (P3 >> lscale_shift_factor)); }
				else if(lscale_int_factor == 2)
				{ P3 = (short)(ZeroLevel + (P3 << 1) + (P3 >> lscale_shift_factor)); }
				else 	// -> 3
				{ P3 = (short)(ZeroLevel + P3 + (P3 << 1) + (P3 >> lscale_shift_factor)); }

				//limiter
				if (P3 > display_max) P3 = display_max;
				if (P3 < display_min) P3 = display_min;
		
				//-----------------------------------------------------------
				//		Draw lines
				//-----------------------------------------------------------
				//DRAWLINEP(X1, Y1, X2, Y2, on, plane);
				DRAWLINEP(lposx, P2, lposx + 1, P3, on, plane);
			}

		}
		else
		{
		//+++++++++++++ draw only single points +++++++++++++
		//BF -> in interpolated TB drop the interpolated values

			if (Selected_Timebase == 3)
			lInterpol = 2;
			else if (Selected_Timebase == 2)
			lInterpol = 4;
			else if (Selected_Timebase == 1)
			lInterpol = 9;
			else if (Selected_Timebase == 0)
			lInterpol = 24;
			else
			lInterpol = 0;

			char ip;

			for (ip=0,lix += timefactor; (lposx - GRID_XOFFS) < (GRID_WIDTH-1); lix += timefactor, ip--)
			//for (lix += timefactor; (lposx - GRID_XOFFS) < GRID_WIDTH-1; lix += timefactor)
			{
				lposx++;
				
				if (ip<=0)
				{
					if (lInterpol == 2)	//toggle faktor between 1 and 2 to simulate 1,5
					lInterpol = 1;
					if (lInterpol == 1)
					lInterpol = 2;
 
					ip = lInterpol;

					P1 = (short) (DisplayData[lix] - ADC_ZERO);
					
					//scaling and Y-positioning
					//P1 = (short)(ZeroLevel + (P1 * lscale_int_factor) + (P1 >> lscale_shift_factor));
					if(lscale_int_factor == 1)
					{ P1 = (short)(ZeroLevel + P1 + (P1 >> lscale_shift_factor)); }
					else if(lscale_int_factor == 2)
					{ P1 = (short)(ZeroLevel + (P1 << 1) + (P1 >> lscale_shift_factor)); }
					else 	// -> 3
					{ P1 = (short)(ZeroLevel + P1 + (P1 << 1) + (P1 >> lscale_shift_factor)); }
	
					if (P1 > display_max) P1 = display_max;
					if (P1 < display_min) P1 = display_min;
				
					PIXELP(lposx, P1, on, plane);
				}
			}
		}

	}


}
//##########################################################################################################################################################
//BF complete new routine and interface
void Display::DRAWSIGNAL_XY(int channel_x, int channel_y, unsigned int start, unsigned char *signal_x, unsigned char *signal_y, unsigned char on, unsigned char vector)
{
	int lsix,ldix; //Signal index and draw index

    	int lX_Ampl1, lX_Ampl2;
	int lY_Ampl1, lY_Ampl2;

	int ZeroLevel_X, ZeroLevel_Y;
	int display_X_max = GRID_XY_XOFFS + GRID_XY - 1;
	int display_Y_max = GRID_YOFFS + GRID_XY - 1;
	int display_X_min = GRID_XY_XOFFS + 1;
	int display_Y_min = GRID_YOFFS + 1;
	
	int lX_scale_int_factor = 1, lX_scale_shift_factor = 1;
	int lY_scale_int_factor = 1, lY_scale_shift_factor = 1;

	unsigned long *lp_plane = NULL;

	
	if (channel_x == 1)
	{	
    		lp_plane = Buffer_Plane1;	//yellow
		//ZeroLevel_X = GRID_XY_XOFFS + ZeroLevelCH1; 
		//ZeroLevel_Y = GRID_YOFFS + ZeroLevelCH2;
	}
	else
	{
		lp_plane = Buffer_Plane3;	//blue
		//ZeroLevel_X = GRID_XY_XOFFS + ZeroLevelCH3; 
		//ZeroLevel_Y = GRID_YOFFS + ZeroLevelCH4;
	}

	ZeroLevel_X = GRID_XY_XOFFS + (GRID_XY / 2); 
	ZeroLevel_Y = GRID_YOFFS + (GRID_XY / 2);

	// calculate amplitude scaling factors for each Channel
	switch (channel_x)
	{	
		case 1: { lX_scale_int_factor = scale_int_factor[Selected_Voltage_CH1];
                          lX_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH1]; break;}
		case 2: { lX_scale_int_factor = scale_int_factor[Selected_Voltage_CH2];
			  lX_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH2]; break;}
		case 3: { lX_scale_int_factor = scale_int_factor[Selected_Voltage_CH3];
			  lX_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH3]; break;}
		case 4: { lX_scale_int_factor = scale_int_factor[Selected_Voltage_CH4];
			  lX_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH4]; break;}		
	}	
	switch (channel_y)
	{	
		case 1: { lY_scale_int_factor = scale_int_factor[Selected_Voltage_CH1];
			  lY_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH1];  break;}
		case 2: { lY_scale_int_factor = scale_int_factor[Selected_Voltage_CH2];
			  lY_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH2];  break;}
		case 3: { lY_scale_int_factor = scale_int_factor[Selected_Voltage_CH3];
			  lY_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH3];  break;}
		case 4: { lY_scale_int_factor = scale_int_factor[Selected_Voltage_CH4];
			  lY_scale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH4];  break;}		
	}	



	if (vector)	//draw vector lines
	{
		//initialize start values beginning with the second value because it will become the new starting point
		lsix = start;
		lX_Ampl2 = (int)(signal_x[lsix] - ADC_ZERO);
		lY_Ampl2 = (int)(signal_x[lsix] - ADC_ZERO);

		//scaling and positioning starting points
		lX_Ampl2 = (int)(ZeroLevel_X - (lX_Ampl2 * lX_scale_int_factor) - (lX_Ampl2 >> lX_scale_shift_factor));
		lY_Ampl2 = (int)(ZeroLevel_Y + (lY_Ampl2 * lY_scale_int_factor) + (lY_Ampl2 >> lY_scale_shift_factor));

		//limiter
		if (lX_Ampl2 > display_X_max) lX_Ampl2 = display_X_max;
		if (lY_Ampl2 > display_Y_max) lY_Ampl2 = display_Y_max;
		
		if (lX_Ampl2 < display_X_min) lX_Ampl2 = display_X_min;
		if (lY_Ampl2 < display_Y_min) lY_Ampl2 = display_Y_min;
		
		//now process the following values
		for (ldix = 0 , lsix += draw_factor;(ldix < GRID_WIDTH) && !UI_request;ldix++, lsix += draw_factor)
		{
			//the new start point is the old end point
			lX_Ampl1 = lX_Ampl2;
			lY_Ampl1 = lY_Ampl2;

			//read next X and Y value
			lX_Ampl2 = (int)(signal_x[lsix] - ADC_ZERO);
			lY_Ampl2 = (int)(signal_y[lsix] - ADC_ZERO);

			//scaling and positioning 
			lX_Ampl2 = (int)(ZeroLevel_X - (lX_Ampl2 * lX_scale_int_factor) - (lX_Ampl2 >> lX_scale_shift_factor));
			lY_Ampl2 = (int)(ZeroLevel_Y + (lY_Ampl2 * lY_scale_int_factor) + (lY_Ampl2 >> lY_scale_shift_factor));

			//limiter
			if (lX_Ampl2 > display_X_max) lX_Ampl2 = display_X_max;
			if (lY_Ampl2 > display_Y_max) lY_Ampl2 = display_Y_max;
			if (lX_Ampl2 < display_X_min) lX_Ampl2 = display_X_min;
			if (lY_Ampl2 < display_Y_min) lY_Ampl2 = display_Y_min;

			//DRAWLINEP(X1, Y1, X2, Y2, on, plane);
			DRAWLINEP(lX_Ampl1, lY_Ampl1, lX_Ampl2, lY_Ampl2, on, lp_plane);

		}
	}
	else	//draw single pixels
	{

		//now process the following values
		for (ldix = 0, lsix = start;(ldix < GRID_WIDTH) && !UI_request;ldix++, lsix += draw_factor)
		{
			//read next X and Y value
			lX_Ampl1 = (int)(signal_x[lsix] - ADC_ZERO);
			lY_Ampl1 = (int)(signal_y[lsix] - ADC_ZERO);

			//scaling and positioning 
			lX_Ampl1 = (int)(ZeroLevel_X - (lX_Ampl1 * lX_scale_int_factor) - (lX_Ampl1 >> lX_scale_shift_factor));
			lY_Ampl1 = (int)(ZeroLevel_Y + (lY_Ampl1 * lY_scale_int_factor) + (lY_Ampl1 >> lY_scale_shift_factor));

			//limiter
			if (lX_Ampl1 > display_X_max) lX_Ampl1 = display_X_max;
			if (lY_Ampl1 > display_Y_max) lY_Ampl1 = display_Y_max;
			if (lX_Ampl1 < display_X_min) lX_Ampl1 = display_X_min;
			if (lY_Ampl1 < display_Y_min) lY_Ampl1 = display_Y_min;

			PIXELP(lX_Ampl1, lY_Ampl1, on, lp_plane);

		}

	}

}
//##########################################################################################################################################################
//BF Draw spectral analysis
void Display::DRAWSPECTRUM_FY(unsigned char on)
{


	int   lZeroLevel     = GRID_HEIGHT_FFT + GRID_YOFFS_FFT + 1;	//gridline is zero -> no signal output
	int   lSignalStart   = GRID_HEIGHT_FFT + GRID_YOFFS_FFT;	//first pixel position
	unsigned long *plane = NULL;

	int   lY = 0;		//amplitude / y position
	int   li = 0; 		//signal index
	int   lX = 0;		//x position

	int lscale_int_factor = 1, lscale_shift_factor = 1;


//printf("\r\ndraw FFT\r\n");

	//----------------------------------------
	//set channel depending parameters
	//----------------------------------------

	//get scaling faktor of active channel
	if(Channel_1_Active)
	{ 	
		plane = Buffer_Plane1;		//Calculate scaling factor
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH1];
		lscale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH1];
	}
	if(Channel_2_Active)
	{ 
		plane = Buffer_Plane2;
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH2];
		lscale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH2];
 	}
	if(Channel_3_Active)
	{ 
		plane = Buffer_Plane3;
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH3];
		lscale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH3];
	 }
	if(Channel_4_Active)
	{ 
		plane = Buffer_Plane4;
		lscale_int_factor   = scale_int_factor[Selected_Voltage_CH4];
		lscale_shift_factor = scale_shift_factor[0][Selected_Voltage_CH4];
	 }

//----------------------------------------------------------------------------------------
//                   draw spectrum
//----------------------------------------------------------------------------------------
	
	lX = GRID_XOFFS_FFT;

	for (li = 0; (lX - GRID_XOFFS_FFT) < (GRID_WIDTH_FFT - 1); li ++)
	{
		lX++;

		//if(lscale_int_factor == 0)
		if(FFT_Mode == FFT_PWSP || FFT_Mode == FFT_PWDN)
		lY = lZeroLevel - SPECTRUM[li]; 	//without scaling - prescaled
		else
		{
			if(lscale_int_factor == 1)
			{ lY = lZeroLevel - (SPECTRUM[li] + (SPECTRUM[li] >> lscale_shift_factor)); }
			else if(lscale_int_factor == 2)
			{ lY = lZeroLevel - ((SPECTRUM[li] << 1) + (SPECTRUM[li] >> lscale_shift_factor)); }
			else 	// -> 3
			{ lY = lZeroLevel - (SPECTRUM[li] + (SPECTRUM[li] << 1) + (SPECTRUM[li] >> lscale_shift_factor)); }
		}	

		// limiter
		if (lY >= lZeroLevel) continue;
		if (lY < GRID_YOFFS_FFT) lY = GRID_YOFFS_FFT;
			
		// Draw line
		if(lSignalStart > lY)
		Connect_Pixels(lX, (short)lZeroLevel, (short)lY,  0, plane, on);
		else
		{ PIXELP(lX, (short)lY, on, plane); }	
		//DRAWLINEP(lX, lY, lX, lSignalStart, on, plane);
	}

}

//##########################################################################################################################################################

void Display::DRAW_SPLASH(unsigned char remove)
{
	unsigned long x;
	char BufText[80];
	char BufText2[80];	
	char BufText3[80];	
	char BufText4[80];
	unsigned char Grid_Color_Buff = GridColor_Val;
	

        printf("Draw Splash\r\n");

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}	
	
	GridColor_Val = WT_Logo_Color_Val;
	Hardware::SetupADC();
	
	sprintf(BufText, "%1i.%1i.BF.%1i.%1i beta", tc_version, tc_subversion, tc_dev_version, tc_dev_subversion);
	sprintf(BufText2, "%X.%c%c", tc_hw_version, tc_production_lot1, tc_production_lot2);
	sprintf(BufText3, "%06d%02d%1X%1X", tc_serial, ((tc_shipment_date & 0x0000FF00) >> 8), ((tc_shipment_date & 0x000000F0) >> 4), (tc_shipment_date & 0x0000000F));	
	sprintf(BufText4, "W%04dA", tc_model);
	
	// Muß auch ins flash
		
        //TEXTOUTvbig("Developed by", Splash_Data_PosX + 28, Splash_Data_PosY - 20, 1, UI_Plane1);		
   	TEXTOUTxvbig("Hayo W. (BlueFlash)", Splash_Logo_PosX - 14, Splash_Data_PosY - 20, 1, UI_Plane1);	
	
	TEXTOUTvbig("Model : ", Splash_Data_PosX + 28, Splash_Data_PosY + 50, 1, UI_Plane1);
	TEXTOUTvbig(BufText4, Splash_Data_PosX + 148, Splash_Data_PosY + 50, 1, UI_Plane1);	
		
	TEXTOUTvbig("Hardware Version : ", Splash_Data_PosX + 28, Splash_Data_PosY + 70, 1, UI_Plane1);
	TEXTOUTvbig(BufText2, Splash_Data_PosX + 148, Splash_Data_PosY + 70, 1, UI_Plane1);		
	TEXTOUTvbig("Software Version : ", Splash_Data_PosX + 28, Splash_Data_PosY + 90, 1, UI_Plane1);
	TEXTOUTvbig(BufText, Splash_Data_PosX + 148, Splash_Data_PosY + 90, 1, UI_Plane1);	
		
	TEXTOUTvbig("Serial Number : ", Splash_Data_PosX + 28, Splash_Data_PosY + 110, 1, UI_Plane1);
	TEXTOUTvbig(BufText3, Splash_Data_PosX + 148, Splash_Data_PosY + 110, 1, UI_Plane1);	 	
		
	TEXTOUTvbig("No Rights Reserved _ 2009", Splash_Data_PosX + 236, Splash_Data_PosY + 250, 1, UI_Plane1);

	AMDFlash::copy_flash_to_plane(WTAG_Logo_Half_Flash, UI_Plane5);
	AMDFlash::copy_flash_to_plane(WTAG_Logo, Grid_Plane);

	Splash_drawed = true;
	
	// Clear Buffer Planes
	for (x = 0; x < 9600; x++)
	{
		Buffer_Plane1[x] = 0;
		Buffer_Plane2[x] = 0;
		Buffer_Plane3[x] = 0;
		Buffer_Plane4[x] = 0;
		Buffer_PlaneM[x] = 0;
		//Buffer_UI2Plane[x] = 0;		 is in marker 1
		Buffer_Mark1Plane[x] = 0;
	}

	dma->np_piodata = 1;											// enable DMA Transfer
	dma->np_piodata = 0;    	
    	
	if (remove)
	{
		//BF del Hardware::Setup_Interrupts();  		
		Search_Auto = true;
		//Hardware::SearchZeros();
		
		nr_delay(2000);	
	
		REMOVE_SPLASH();
		Splash_drawed = false;
	}

	if (Splash_drawed == false)
	{
		New_Menu = 14;
	
		Menu_Changed = 1;
    		UpdateMenuTextPlane = true;	
	}
	printf("Draw Splash finished\r\n");	

}

//##########################################################################################################################################################

void Display::DRAWSQUAREBUTTON(int posx, int posy, int sizex, int sizey, unsigned char pushed, unsigned char remove)
{
	char set;
	unsigned long *iplane;			
		
	if (remove) set = 0;
	else set = 1;
	
	// Left Edge	
	if (pushed) iplane = UI_Plane5;
	else iplane = UI_Plane1;
	
	PIXELP(posx + 1, posy + 2, set, iplane);
	PIXELP(posx + 2, posy + 1, set, iplane);
	
	PIXELP(posx + 2, posy + 2, !set, UI_Plane3);	
	
	// Upper Middle
	DRAWP(posx + 3, posy, sizex - 6, 1, set, iplane);					// TopLine

	// Middle Block
	DRAWP(posx + 3, posy + 1, sizex - 6, 2, !set, UI_Plane3);				// Middle Block	
	
	// Right Edge		
	PIXELP(posx + (sizex - 3), posy + 1, set, iplane);
	PIXELP(posx + (sizex - 3) + 1, posy + 2, set, iplane);
	PIXELP(posx + (sizex - 3), posy + 2, !set, UI_Plane3);
	
	// Middle Block
	DRAWP(posx + 1, posy + 3, sizex - 2, sizey - 6, !set, UI_Plane3); //1
	
	// Sidelines
	if (pushed)
	{
		DRAWP(posx, posy + 3, 1, sizey - 6, set, UI_Plane5);
		DRAWP(posx + sizex - 1, posy + 3, 1, sizey - 6, set, UI_Plane1);
	}
	else
	{
		DRAWP(posx, posy + 3, 1, sizey - 6, set, UI_Plane1);
		DRAWP(posx + sizex - 1, posy + 3, 1, sizey - 6, set, UI_Plane5);
	}
		
	if (pushed) iplane = UI_Plane1;
	else iplane = UI_Plane5;
			
	// Down
	// Left Edge	
	PIXELP(posx + 1, posy + (sizey - 3), set, iplane);
	PIXELP(posx + 2, posy + (sizey - 3) + 1, set, iplane);
	PIXELP(posx + 2, posy + (sizey - 3), !set, UI_Plane3);

	// Lower Middle
	DRAWP(posx + 3, posy + (sizey - 1), sizex - 6, 1, set, iplane);	// Bottom Line

	DRAWP(posx + 3, posy + (sizey - 3), sizex - 6, 2, !set, UI_Plane3);		// Middle Block //1

	// Right Edge
	PIXELP(posx + (sizex - 3) + 1, posy + (sizey - 3), set, iplane);
	PIXELP(posx + (sizex - 3), posy + (sizey - 3) + 1, set, iplane);
	PIXELP(posx + (sizex - 3), posy + (sizey - 3), !set, UI_Plane3);
}
//##########################################################################################################################################################

void Display::DRAWSTATUS(int Which, int isChanging)
{
	unsigned char xe = 0;
	unsigned char xf = 0;	
	unsigned short Buffer = 0;
	char BufferText[17];
	char BufferText2[17];
#ifdef _Debug_	
    printf("DS %d iC %d\n", Which, isChanging);
#endif			
	switch(Which)
	{
		// Timebase
		case 0:
		{
			if (MenuStatus[10][1] == 1) // Delayed Mode
			{
				// If One statusbutton aktive and not the timebase -> remove it
				if ((isChanging == 1) && (StatusbarChanged > 0))
				{
						if (StatusbarChanged != 11) Display::RemoveStatusBtn();
						Hardware::ResetTimer();							// Reset the Timer
				}	
								
				if ((isChanging == 1) && (StatusbarChanged == 0))
				{
				DRAWROUNDBUTTON(326, 0, 64, 20, btnUnpushed, btnDraw);					// Draw Button	
						//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
						StatusbarChanged = 11;
				}
		
				DRAWP(333, 0, 132, 18, 0, UI_Plane2);								// Clear First            (406, 0
		
				sprintf(BufferText, "");
				for (xe = 0; xe < 10; xe++)
				{
						BufferText[xe] = TimebaseData_Matrix[dmode_Selected_Timebase][dmode_SIGNALFaktor_idx][xe];	
				}
				TEXTOUTxvbig(BufferText, 335 + TimebaseDataDef[dmode_Selected_Timebase], 2, 1, UI_Plane2);	// Draw Menu Text
					
				sprintf(BufferText, "");
				for (xe = 0; xe < 10; xe++)
				{
					BufferText[xe] = TimebaseData_Matrix[Selected_Timebase][SIGNALFaktor_idx][xe];	
				}
				TEXTOUTxvbig(BufferText, 413 + TimebaseDataDef[Selected_Timebase], 2, 1, UI_Plane2);		// Draw Menu Text
			}  /*
			else if (MenuStatus[10][2] == 1) // Roll Mode
			{
				// If One statusbutton aktive and not the timebase -> remove it
				if ((isChanging == 1) && (StatusbarChanged > 0))
				{
						if (StatusbarChanged != 10) Display::RemoveStatusBtn();
						Hardware::ResetTimer();							// Reset the Timer
				}	
								
				if ((isChanging == 1) && (StatusbarChanged == 0))
				{
				DRAWROUNDBUTTON(404, 0, 64, 20, btnUnpushed, btnDraw);								// Draw Button	
			//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
						StatusbarChanged = 10;
				}
		
				DRAWP(333, 0, 132, 18, 0, UI_Plane2);								// Clear First            (406, 0
			*/  /*
				sprintf(BufferText, "");
				for (xe = 0; xe < 10; xe++)
				{
						BufferText[xe] = SampleRateData[Selected_Timebase][xe];	// Offset to Text in MenuBlock 0x00200000
				}
				TEXTOUTxvbig(BufferText, 335 + SampleRateDataDef[Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
					*/  /*
				sprintf(BufferText, "");
				for (xe = 0; xe < 10; xe++)
				{
				BufferText[xe] = TimebaseData[25 + ROLLMODE_TB][xe];	// Offset to Text in MenuBlock 0x00200000
				}
				TEXTOUTxvbig(BufferText, 413 + TimebaseDataDef[25 + ROLLMODE_TB], 2, 1, UI_Plane2);					// Draw Menu Text
			}	*/			
			else // Main Mode
			{
				// If One statusbutton aktive and not the timebase -> remove it
				if ((isChanging == 1) && (StatusbarChanged > 0))
				{
						if (StatusbarChanged != 10) Display::RemoveStatusBtn();
						Hardware::ResetTimer();										// Reset the Timer
				}	
								
				if ((isChanging == 1) && (StatusbarChanged == 0))
				{
				DRAWROUNDBUTTON(404, 0, 64, 20, btnUnpushed, btnDraw);						// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
						StatusbarChanged = 10;
				}
		
				DRAWP(333, 0, 132, 18, 0, UI_Plane2);								// Clear First            (406, 0
		
				sprintf(BufferText, "");
				for (xe = 0; xe < 11; xe++)
				{
					BufferText[xe] = SampleRateData[Selected_Timebase][xe];	// Offset to Text in MenuBlock 0x00200000
				}
				TEXTOUTxvbig(BufferText, 335 + SampleRateDataDef[Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
					
				sprintf(BufferText, "");
				for (xe = 0; xe < 10; xe++)
				{
				BufferText[xe] = TimebaseData_Matrix[Selected_Timebase][SIGNALFaktor_idx][xe];	// Offset to Text in MenuBlock 0x00200000
				}
				TEXTOUTxvbig(BufferText, 413 + TimebaseDataDef[Selected_Timebase], 2, 1, UI_Plane2);					// Draw Menu Text
			}
								
			
            		TimebaseChanged = 0;
			
			break;
		}
			
		// Voltage CH 1	
		case 1:
		{	
			CALCVOLTAGE(1, &BufferText[0]);											// Calculate Text

			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 1) Display::RemoveStatusBtn();
				Hardware::ResetTimer();												// Reset the Timer
			}
					
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(15, 0, 64, 20, btnUnpushed, btnDraw);						// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 1;
			}

			DRAWP(16, 0, 62, 18, 0, UI_Plane2);						// Clear First
								
			TEXTOUTxvbig(BufferText, 24, 2, 1, UI_Plane2);					// Draw Voltage Text
			
			VoltageChangedCh1 = 0;
			
			break;
		}
		
		// Voltage CH 2	
		case 2:
		{
			CALCVOLTAGE(2, &BufferText[0]);							// Calculate Text
			
			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 2) Display::RemoveStatusBtn();
				Hardware::ResetTimer();							// Reset the Timer
			}
			
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(91, 0, 64, 20, btnUnpushed, btnDraw);			// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 2;
			}	
	
			DRAWP(92, 0, 61, 18, 0, UI_Plane2);											// Clear First
			
			TEXTOUTxvbig(BufferText, 100, 2, 1, UI_Plane2);					// Draw Voltage Text

			VoltageChangedCh2 = 0;
			
			break;
		}

		// Voltage CH 3	
		case 3:
		{
			CALCVOLTAGE(3, &BufferText[0]);											// Calculate Text

			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 3) Display::RemoveStatusBtn();
				Hardware::ResetTimer();												// Reset the Timer
			}	
			
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(167, 0, 64, 20, btnUnpushed, btnDraw);			// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 3;
			}	

			DRAWP(174, 0, 55, 18, 0, UI_Plane2);								// Clear First
		
			TEXTOUTxvbig(BufferText, 176, 2, 1, UI_Plane2);					// Draw Voltage Text

			VoltageChangedCh3 = 0;
			
			break;
		}
		
		// Voltage CH 4
		case 4:
		{
			CALCVOLTAGE(4, &BufferText[0]);											// Calculate Text

			if ((isChanging == 1) && (StatusbarChanged > 0))
			{
				if (StatusbarChanged != 4) Display::RemoveStatusBtn();
				Hardware::ResetTimer();										// Reset the Timer
			}	
			
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(243, 0, 64, 20, btnUnpushed, btnDraw);						// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 4;
			}

			DRAWP(244, 0, 65, 18, 0, UI_Plane2);									// Clear First

			TEXTOUTxvbig(BufferText, 252, 2, 1, UI_Plane2);								// Draw Voltage Text

			VoltageChangedCh4 = 0;
			
			break;
		}	
		
		// Timebase Offset  // Muß noch upgedated werden
		case 5:
		{

			
	//		if (isChanging == 1) DRAWROUNDBUTTON(330, 0, 76, 20, btnUnpushed, btnDraw);			// Button
	//		else
//			DRAWP(338, 0, 62, 18, 0, UI_Plane2);									// Clear First
			
            		Display::DRAW_ALL_CURSOR();			
            			
			TimeOffsetChanged = 0;

    			
			break;
		}		
		
		// Trigger Level
		case 6:
		{		
			DRAWP(560, 0, 79, 18, 0, UI_Plane2);									// Clear First
            		
			//if (triggering == 0) return;
			if (MenuStatus[14][3] == 1) return;       // Ext Trig TV Ch1
			if (MenuPopupStatus[8][2] == 3) return;   // Ext Trig Line

			CALCTRIGGER();												// Calculate Text
            /*
			if (((isChanging == 1) && (StatusbarChanged > 0)) || (MenuStatus[10][2] == 1))
			{
				if (StatusbarChanged != 6) Display::RemoveStatusBtn();
				Hardware::ResetTimer();										// Reset the Timer
			}	
          	*/		
			//if ((isChanging == 1) && (StatusbarChanged == 0) && (MenuStatus[10][2] == 0))
			if ((isChanging == 1) && (StatusbarChanged == 0))
			{
				DRAWROUNDBUTTON(558, 0, 82, 20, btnUnpushed, btnDraw);						// Draw Button	
				//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
				StatusbarChanged = 6;
			}		
				
			//if (MenuStatus[10][2] == 0)
			{
				if (MenuStatus[14][2] == 1) TEXTOUTxvbig(Trigger_ExtLevel_Str.Read_Text(), 567, 2, 1, UI_Plane2);	// Draw Voltage Text
				else TEXTOUTxvbig(Trigger_Level_Str.Read_Text(), 567, 2, 1, UI_Plane2);					// Draw Voltage Text
			}
					
		
			TriggerLevelChanged = 0;
			
			break;
		}	
		
		// Trigger Auto
		case 7:
		{
			if (Continius)
			{	
				BITBITMAP(bitbmStopTrigger, 464, 0, 1, UI_Plane3);           // Muß eventuell ins Flash
				BITBITMAP(bitbmStopTrigger_stop, 464, 6, 0, UI_Plane1);           // Muß eventuell ins Flash
				//DRAWP(464, 0, 50, 18, 1, UI_Plane3);								// Clear First
				DRAWP(464, 0, 50, 18, 0, UI_Plane2);								// Clear First
				DRAWP(464, 0, 50, 18, 0, Channel_Plane4);								// Clear First
				DRAWP(464, 0, 50, 18, 0, Buffer_Plane4);								// Clear First
					
				//if (MenuStatus[10][2] == 1) sprintf(BufferText, "Free");
				//else
				if (MenuStatus[12][0] == 93) sprintf(BufferText, "Auto");
				else sprintf(BufferText, "Norm");
					
							
				TEXTOUTxvbig(BufferText, 471, 2, 1, UI_Plane2);					// Draw Voltage Text		
			}
			else
			{
				DRAWP(464, 0, 50, 18, 0, UI_Plane2);								// Clear First
				//DRAWP(464, 0, 50, 18, 0, UI_Plane3);								// Clear First
				//DRAWP(464, 0, 50, 18, 0, UI_Plane4);								// Clear First
				BITBITMAP(bitbmStopTrigger, 464, 0, 0, UI_Plane3);              // Muß eventuell ins Flashen vom Flash beim starten
				BITBITMAP(bitbmStopTrigger, 464, 0, 1, Channel_Plane4);           // Muß eventuell ins Flashen vom Flash beim starten
				BITBITMAP(bitbmStopTrigger, 464, 0, 1, Buffer_Plane4);           // Muß eventuell ins Flashen vom Flash beim starten
				BITBITMAP(bitbmStopTrigger_stop, 464, 6, 1, UI_Plane1);           // Muß eventuell ins Flashen vom Flash beim starten
		
		
			}
			
			TriggerModeChanged = 0;
			
			break;
		}
		
		// Trigger Way
		case 8:
		{
			DRAWP(517, 0, 40, 18, 0, UI_Plane2);									// Clear First
#ifdef _Debug_			
			printf("TW %d MS[14][1] %d MS[14][2] %d MS[14][3] %d STS %d SEE %d\n", TriggerWay, MenuStatus[14][1], MenuStatus[14][2], MenuStatus[14][3], Selected_Trigger_Source, SelectedEdgeExtern);
#endif
			switch(TriggerWay)
			{
				case 1:	
				{
					if (MenuStatus[14][1] == 138)
					{
						xe = '1';
						xf = ' ';
						Selected_Trigger_Source = 1;
					}					
					else if (MenuStatus[14][1] == 139)
					{
						xe = '2';
						xf = ' ';
						Selected_Trigger_Source = 2;
					}
					else if (MenuStatus[14][1] == 140)
					{
						xe = '3';
						xf = ' ';
						Selected_Trigger_Source = 3;
					}
                    			else if (MenuStatus[14][1] == 141)
					{
						xe = '4';
						xf = ' ';
						Selected_Trigger_Source = 4;
					}
					
                    			if ((MenuStatus[14][2] == 1) && (SelectedEdgeExtern == 0) && (MenuPopupStatus[8][0] == 3))
					{
						xe = 'X';
						xf = 'L';
						Selected_Trigger_Source = 5;
					}
					
                    			if ((MenuStatus[14][2] == 1) && (SelectedEdgeExtern == 0) && (MenuPopupStatus[8][1] == 3))
					{
						xe = 'X';
						xf = 'H';
						Selected_Trigger_Source = 5;
					}					
					
                    			if ((MenuStatus[14][2] == 1) && (SelectedEdgeExtern == 1) && (MenuPopupStatus[8][2] == 3))
					{
						xe = 'L';
						xf = ' ';
						Selected_Trigger_Source = 6;
					}
					
                    			if ((MenuStatus[14][3] == 1) && (SelectedEdgeExtern == 2))
					{
						xe = 'T';
						xf = 'V';
						Selected_Trigger_Source = 6;
					}

					// if channel who triggers is inverted
					if (MenuStatus[(MenuStatus[14][1] - 137)][2] == 241)
					{					
						switch(MenuStatus[14][0])
						{
							case 2:	sprintf(BufferText, "~ %c%c", xe, xf); break;
							case 3:	sprintf(BufferText, "} %c%c", xe, xf); break;			
						}	
					}
					else
					{					
						switch(MenuStatus[14][0])
						{
							case 2:	sprintf(BufferText, "} %c%c", xe, xf); break;
							case 3:	sprintf(BufferText, "~ %c%c", xe, xf); break;			
						}	
					}
                    
					break;	
                    		
				}
							
				case 2:
				{				
					switch(MenuStatus[15][0])
					{
						case 138 : xe = '1'; Selected_Trigger_Source = 1; break;
						case 139 : xe = '2'; Selected_Trigger_Source = 2; break;
						case 140 : xe = '3'; Selected_Trigger_Source = 3; break;
						case 141 : xe = '4'; Selected_Trigger_Source = 4; break;
						case 142 : xe = 'X'; Selected_Trigger_Source = 5; break;
					}
					/*				
					switch(MenuStatus[15][1])
					{
						case 2:	sprintf(BufferText, "%c %c", 138, xe); break;
						case 3:	sprintf(BufferText, "%c %c", 139, xe); break;			
					}	
                    */					
					sprintf(BufferText, "%c %c", 138, xe);
					
					break;
				}
				
				case 3:  // Kann raus
				{				
					switch(MenuStatus[23][0])
					{
						case 138 : xe = '1'; Selected_Trigger_Source = 1; break;
						case 139 : xe = '2'; Selected_Trigger_Source = 2; break;
						case 140 : xe = '3'; Selected_Trigger_Source = 3; break;
						case 141 : xe = '4'; Selected_Trigger_Source = 4; break;
						case 142 : xe = 'X'; Selected_Trigger_Source = 5; break;
					}
									
					sprintf(BufferText, "Pat %c", xe);
						
					break;
				}						
			}
			
			
			//if (MenuStatus[10][2] == 0)
			{            	
                		TEXTOUTxvbig(BufferText, 520, 2, 1, UI_Plane2);					// Draw Triggerway Text
            		}			
			TriggerWayChanged = 0;
			
			break;
		}				
	}
}		
//##########################################################################################################################################################

void Display::DRAWZEROPOPUP(int channel)
{
	int x, y;
	int pos = 0;
	int volt = 0;
	
	
	float voltoff = 0;
	char voltstrn[20];
	char voltunit[3] = "uV";	
	
	unsigned char PixelBuffer;

	double factor = 0;
	double ffactor = 0;	
	
	short *fprobe = 0;
	int *fzeropos = 0;
	volatile char *fselected_voltage = 0;
	
	Hardware::ResetTimer();

	switch (channel)
	{
		case 1:
		{
			fprobe = &MenuStatus[1][3];
			fselected_voltage = &Selected_Voltage_CH1;
			fzeropos = &ZeroLevelCH1;			
			break;
		}	
		case 2:
		{
			fprobe = &MenuStatus[2][3];
			fselected_voltage = &Selected_Voltage_CH2;
			fzeropos = &ZeroLevelCH2;
			break;
		}
		case 3:
		{
			fprobe = &MenuStatus[3][3];
			fselected_voltage = &Selected_Voltage_CH3;
			fzeropos = &ZeroLevelCH3;
			break;
		}
		case 4:
		{
			fprobe = &MenuStatus[4][3];
			fselected_voltage = &Selected_Voltage_CH4;
			fzeropos = &ZeroLevelCH4;
			break;
		}
	}
	
	if ((channel != dzp_channel_buf) || (*fprobe != dzp_fprobe_buf) || (*fselected_voltage != dzp_fselected_voltage_buf))
	{								
		switch((int) *fselected_voltage)
		{
			case 0:	 factor = 20.833333; break;
			case 1:	 factor = 41.666666; break;
			case 2:	 factor = 104.166666; break;
			case 3:	 factor = 208.333333; break;
			case 4:	 factor = 416.666666; break;
			case 5:	 factor = 1041.666666; break;
			case 6:	 factor = 2083.33333; break;
			case 7:	 factor = 4166.66666; break;
			case 8:	 factor = 10416.6666; break;
			case 9:	 factor = 20833.3333; break;
			case 10: factor = 41666.6666; break;
			case 11: factor = 104166.66; break;																						
		}

		switch ((int) *fprobe)
		{
			case 101: ffactor = 10000000; break;
			case 102: ffactor = 5000000; break;
			case 103: ffactor = 2000000; break;
			case 104: ffactor = 1000000; break;
			case 105: ffactor = 500000; break;
			case 106: ffactor = 200000; break;
			case 107: ffactor = 100000; break;
			case 108: ffactor = 50000; break;
			case 109: ffactor = 20000; break;
			case 110: ffactor = 10000; break;
			case 111: ffactor = 5000; break;
			case 112: ffactor = 2000; break;
			case 113: ffactor = 1000; break;
		}
			
		factor = factor / ffactor;
		
		dzp_factor_buf = factor;
		dzp_channel_buf = channel;
		dzp_fprobe_buf = *fprobe;
		dzp_fselected_voltage_buf = *fselected_voltage;
	}
	else factor = dzp_factor_buf;
		
// BF del	voltoff =  (float)(*fzeropos - 0xC0) * factor;  // Mitte ist (GRID_HEIGHT / 2) (0xC0) =>  Mitte 128 (0x80) * 1.5
	
	voltoff =  (float)(*fzeropos - (GRID_HEIGHT / 2)) * factor;  // Mitte ist (GRID_HEIGHT / 2) BF
				
	switch (channel)
	{
		case 1:			
		{
			Zero_Level1_Str.Write_Value(voltoff);	
			Zero_Level1_Str.RenderText();
			break;
		}
		case 2:	
		{
			Zero_Level2_Str.Write_Value(voltoff);	
			Zero_Level2_Str.RenderText();
			break;
		}
		case 3:			
		{
			Zero_Level3_Str.Write_Value(voltoff);	
			Zero_Level3_Str.RenderText();
			break;
		}
		case 4:			
		{
			Zero_Level4_Str.Write_Value(voltoff);	
			Zero_Level4_Str.RenderText();
			break;
		}
	}	
	if (ZeroPopupChanged == 0)
	{
		//DRAWP(450, 51, 160, 22, 1, UI_Plane1);	
		//DRAWP(450, 51, 160, 22, 1, Buffer_UI2Plane);
		
		DRAWROUNDBUTTON(447, 51, 166, 25, btnUnpushed, btnDraw);
		
	}
	else DRAWP(460, 51, 150, 21, 0, UI_Plane2);
	
	ZeroPopupChanged = 1;		
	
	switch (channel)
	{
		case 1:	TEXTOUTxvbig(Zero_Level1_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text	
		case 2:	TEXTOUTxvbig(Zero_Level2_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text	
		case 3:	TEXTOUTxvbig(Zero_Level3_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text	
		case 4:	TEXTOUTxvbig(Zero_Level4_Str.Read_Text(), 460, 55, 1, UI_Plane2);break;	// Draw Zero Text
	}
	//timer_rotary_busy->np_timercontrol = ((timer_rotary_busy->np_timercontrol & 3) + np_timercontrol_start_mask);// | np_timercontrol_cont_mask;	// Start Timer
}
//##########################################################################################################################################################

void Display::DRAWZEROPOPDOWN(void)
{
	char Ct;
	
	int xa = 50 * 20;
	
	for (Ct = 0; Ct < 24; Ct++)
	{			
		*(UI_Plane1 + xa + 14) = 0;
		*(UI_Plane1 + xa + 15) = 0; 
		*(UI_Plane1 + xa + 16) = 0; 
		*(UI_Plane1 + xa + 17) = 0; 
		*(UI_Plane1 + xa + 18) = 0; 
		*(UI_Plane1 + xa + 19) = *(UI_Plane1 + xa + 19) & 0x0000000F;

		*(Buffer_UI2Plane + xa + 14) = 0;
		*(Buffer_UI2Plane + xa + 15) = 0;
		*(Buffer_UI2Plane + xa + 16) = 0;
		*(Buffer_UI2Plane + xa + 17) = 0;
		*(Buffer_UI2Plane + xa + 18) = 0;
		*(Buffer_UI2Plane + xa + 19) = *(Buffer_UI2Plane + xa + 19) & 0x0000000F;

		*(UI_Plane3 + xa + 14) = 0;
		*(UI_Plane3 + xa + 15) = 0;
		*(UI_Plane3 + xa + 16) = 0;
		*(UI_Plane3 + xa + 17) = 0;
		*(UI_Plane3 + xa + 18) = 0;
		*(UI_Plane3 + xa + 19) = *(UI_Plane3 + xa + 19) & 0x0000000F;

		*(UI_Plane4 + xa + 14) = 0;
		*(UI_Plane4 + xa + 15) = 0;
		*(UI_Plane4 + xa + 16) = 0;
		*(UI_Plane4 + xa + 17) = 0;
		*(UI_Plane4 + xa + 18) = 0;
		*(UI_Plane4 + xa + 19) = *(UI_Plane4 + xa + 19) & 0x0000000F;

		*(UI_Plane5 + xa + 14) = 0;
		*(UI_Plane5 + xa + 15) = 0;
		*(UI_Plane5 + xa + 16) = 0;
		*(UI_Plane5 + xa + 17) = 0;
		*(UI_Plane5 + xa + 18) = 0;
		*(UI_Plane5 + xa + 19) = *(UI_Plane5 + xa + 19) & 0x0000000F;
		xa += 20;
	}	
	ZeroPopupChanged = 0;
	UpdateMenuTextPlane = true;
}
